require "luas.shortcuts"
require "luas.extendedLoader"
require "luas.boundingBox"

Boss2 = Object:extend()


function Boss2.new(self) --, aPosX, aPosY) position only known at activation time
	
	self:reset() --lots of other values initialized here and also reset to defaults on deactivation

end


function Boss2:reset()

	self.active = false	
	
	self.hitPoints = 1 --basic before activation
	
	self.takenHits = 0 --taken hit since last update? insert number hitpoints to be taken

	self.scoreReward = 0                    --see defineColorType
	
	self.enmWidth  = 0 
	self.enmHeight = 0 
	
	self.currentGph  = nil
	
	self.x = 0
	self.y = 0
	
	self.startPosX = 0 
	self.startPosY = 0
	
	self.moveState = 0 --invalid value
	self.movePtX = {}
	self.movePtY = {}
	self.movePtX[1] = 142
	self.movePtY[1] = 0
	self.movePtX[2] = 142
	self.movePtY[2] = 0
	self.movePtX[3] = 0
	self.movePtY[3] = 0
	self.movePtX[4] = 0
	self.movePtY[4] = 108
	self.movePtX[5] = 142
	self.movePtY[5] = 108
	
	--####################
	--# Shooting         #
	--####################
	
	self.shootTimer = 0
	self.shootTimerMax = 70
		
end

function Boss2.putStartPosition(self, aPx, aPy)

	self.x = aPx
	self.y = aPy
	
	self.startPosX = aPx 
	self.startPosY = aPy
end

function Boss2.activate(self)
	
	self.active = true
	
	self.currentGph = enmBoss2Gph
	
	self.scoreReward = 2000
	
	self.enmWidth  = 57
	self.enmHeight = 41
	
	self.hitPoints = 200
	
	self.shootTimer = self.shootTimerMax
	
	self.moveState = 1 --valid value bzw. init value
	
end

function Boss2.plantExplosion(self)

	
	globBoss2Explosion.activate(globBoss2Explosion, self.x, self.y)
	
end

function Boss2.takeHit(self, aDmg)

	self.takenHits = self.takenHits + aDmg --adding up damage from multiple bullets in 1 update possible
end

function Boss2.deactivate(self)

	--self.active = false --is not enough, will cause carry-over of behaviors such as matrix/roaming mode
	
	--clean it up on deactivation
	self:reset()
end

function Boss2.doUpdate(self)


	if self.active == true then
	
		if self.takenHits > 0 then --flag set by gamemode, need to take hp and check for death
			self.hitPoints = self.hitPoints - self.takenHits
			
			self.takenHits = 0 --otherwise will take more hitpoints in next update
		
			if self.hitPoints <= 0 then
				self.plantExplosion(self)
				
				globAddScore(self.scoreReward)
				--bugfix: add score BEFORE deactivation
				
				print("Enemy dies")
				
				
				--if globIsInDemoMode == false then 
				--	impactSnd:stop()
				--	impactSnd:play()
				--end
				
				self.deactivate(self)
				
				
				globBossBeaten = true
				globBossBeatTimer = 250
				
				globLevelMusic:stop()
			else
				if globIsInDemoMode == false then 
					bossHitSnd:stop()
					bossHitSnd:play()
				end
			end
		end
	end
	
	--only if still active
	if self.active == true then
		self.executeFlyMove(self) --always as long as active: move along the x axis
	end
end

function Boss2.executeFlyMove(self)

	if self.moveState == 1 then
	
		self.x = self.x - 1
		
		local lclDirectionVectorX = self.movePtX[self.moveState] - self.x
		local lclDirectionVectorY = self.movePtY[self.moveState] - self.y --need no offsety
		
		local lclVectorLength = math.sqrt(lclDirectionVectorX * lclDirectionVectorX + lclDirectionVectorY * lclDirectionVectorY)
		
		if lclVectorLength < 1.5 then
			self.x = self.movePtX[self.moveState]
			self.y = self.movePtY[self.moveState]
			self.plantShot(self, self.moveState)
			self.moveState = 3
		end
	
	elseif self.moveState == 2 then
	
		self.y = self.y - 2
		
		local lclDirectionVectorX = self.movePtX[self.moveState] - self.x
		local lclDirectionVectorY = self.movePtY[self.moveState] - self.y --need no offsety
		
		local lclVectorLength = math.sqrt(lclDirectionVectorX * lclDirectionVectorX + lclDirectionVectorY * lclDirectionVectorY)
		
		if lclVectorLength < 1.5 then
			self.x = self.movePtX[self.moveState]
			self.y = self.movePtY[self.moveState]
			self.plantShot(self, self.moveState)
			self.moveState = 3
		end
	
	elseif self.moveState == 3 then
	
		self.x = self.x - 2
		
		local lclDirectionVectorX = self.movePtX[self.moveState] - self.x
		local lclDirectionVectorY = self.movePtY[self.moveState] - self.y --need no offsety
		
		local lclVectorLength = math.sqrt(lclDirectionVectorX * lclDirectionVectorX + lclDirectionVectorY * lclDirectionVectorY)
		
		if lclVectorLength < 1.5 then
			self.x = self.movePtX[self.moveState]
			self.y = self.movePtY[self.moveState]
			self.plantShot(self, self.moveState)
			self.moveState = 4
		end
	
	elseif self.moveState == 4 then
	
		self.y = self.y + 2
		
		local lclDirectionVectorX = self.movePtX[self.moveState] - self.x
		local lclDirectionVectorY = self.movePtY[self.moveState] - self.y --need no offsety
		
		local lclVectorLength = math.sqrt(lclDirectionVectorX * lclDirectionVectorX + lclDirectionVectorY * lclDirectionVectorY)
		
		if lclVectorLength < 1.5 then
			self.x = self.movePtX[self.moveState]
			self.y = self.movePtY[self.moveState]
			self.plantShot(self, self.moveState)
			self.moveState = 5
		end
	
	elseif self.moveState == 5 then
	
		self.x = self.x + 2
		
		local lclDirectionVectorX = self.movePtX[self.moveState] - self.x
		local lclDirectionVectorY = self.movePtY[self.moveState] - self.y --need no offsety
		
		local lclVectorLength = math.sqrt(lclDirectionVectorX * lclDirectionVectorX + lclDirectionVectorY * lclDirectionVectorY)
		
		if lclVectorLength < 1.5 then
			self.x = self.movePtX[self.moveState]
			self.y = self.movePtY[self.moveState]
			self.plantShot(self, self.moveState)
			self.moveState = 2
		end
	
	end

	--self.moveState = 0 --invalid value
	--self.movePtX = {}
	--self.movePtY = {}
	--self.movePtX[1] = 142
	--self.movePtY[1] = 0
	--self.movePtX[2] = 142
	--self.movePtY[2] = 0
	--self.movePtX[3] = 0
	--self.movePtY[3] = 0
	--self.movePtX[4] = 0
	--self.movePtY[4] = 108
	--self.movePtX[5] = 142
	--self.movePtY[5] = 108
	
		
	if self.shootTimer > 0 then
		self.shootTimer = self.shootTimer - 1
	end
		
	if self.shootTimer <= 0 then
		self.shootTimer = self.shootTimerMax
		self.plantBigShot(self)
	end
	
end

function Boss2.plantBigShot(self)


	local lclLaunchPX = self.x + 25
	local lclLaunchPY = self.y + 17
	
	local lclXSpd = 0.0
	local lclYSpd = 0.0
	local lclSkip = false
	

	lclXSpd = globPlShip[1].x + 8 - lclLaunchPX
	lclYSpd = globPlShip[1].y + 6 - lclLaunchPY
		
	local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		
	if lclVectorLength < epsilon then
		lclSkip = true
	else
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength
			
		lclXSpd = lclXSpd*2.6
		lclYSpd = lclYSpd*2.6
	end
	
	if lclSkip == false then

		globEnmBulletsF[globEnmBulletsFIndex].activate(globEnmBulletsF[globEnmBulletsFIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		
		globEnmBulletsFIndex = globEnmBulletsFIndex + 1
		if globEnmBulletsFIndex >= globEnmBulletsFIndexMax then
			globEnmBulletsFIndex = 1
		end
		
		if globIsInDemoMode == false then 
			shotSnd:stop()
			shotSnd:play()
		end
	
	end
end

function Boss2.plantShot(self, aState)

	local lclLaunchPX = self.x + 28
	local lclLaunchPY = self.y + 20
	
	local lclXSpd = 0.0
	local lclYSpd = 0.0
	local lclTotalSpeed = 4.0
	
	if aState <= 2 then
	
		--left bullet
		lclXSpd = (-1)*1.0
		lclYSpd = 0.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
	
		--lower bullet
		lclXSpd = 0.0
		lclYSpd = 1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
	
		--lower left bullet
		lclXSpd = (-1)*1.0
		lclYSpd = 1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
		
		--lower lower left bullet
		lclXSpd = (-1)*1.0
		lclYSpd = 2.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
		
		--lower left left bullet
		lclXSpd = (-1)*2.0
		lclYSpd = 1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
	
	elseif aState == 3 then
	
		--right bullet
		lclXSpd = 1.0
		lclYSpd = 0.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
	
		--lower right bullet
		lclXSpd = 1.0
		lclYSpd = 1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
	
		--lower bullet
		lclXSpd = 0.0
		lclYSpd = 1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
		
		--lower lower right bullet
		lclXSpd = 1.0
		lclYSpd = 2.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
		
		--lower right right bullet
		lclXSpd = 2.0
		lclYSpd = 1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
	
	elseif aState == 4 then
	
		--upper bullet
		lclXSpd = 0.0
		lclYSpd = (-1)*1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
	
		--upper right bullet
		lclXSpd = 1.0
		lclYSpd = (-1)*1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
	
		--right bullet
		lclXSpd = 1.0
		lclYSpd = 0.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
		
		--upper upper right bullet
		lclXSpd = 1.0
		lclYSpd = (-1)*2.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
		
		--upper right right bullet
		lclXSpd = 2.0
		lclYSpd = (-1)*1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
	

	
	elseif aState == 5 then
	
		--left bullet
		lclXSpd = (-1)*1.0
		lclYSpd = 0.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end

		--left upper bullet 
		lclXSpd = (-1)*1.0
		lclYSpd = (-1)*1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
	
		--upper bullet
		lclXSpd = 0.0
		lclYSpd = (-1)*1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
		
		--left upper upper bullet 
		lclXSpd = (-1)*1.0
		lclYSpd = (-1)*2.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end
		
		--left left upper bullet 
		lclXSpd = (-1)*2.0
		lclYSpd = (-1)*1.0
		local lclVectorLength = math.sqrt(lclXSpd * lclXSpd + lclYSpd * lclYSpd)
		lclXSpd = lclXSpd/lclVectorLength
		lclYSpd = lclYSpd/lclVectorLength	
		lclXSpd = lclXSpd*lclTotalSpeed
		lclYSpd = lclYSpd*lclTotalSpeed
		--
		globEnmBulletsA[globEnmBulletsAIndex].activate(globEnmBulletsA[globEnmBulletsAIndex], lclLaunchPX, lclLaunchPY, lclXSpd, lclYSpd)
		--	
		globEnmBulletsAIndex = globEnmBulletsAIndex + 1
		if globEnmBulletsAIndex >= globEnmBulletsAIndexMax then
			globEnmBulletsAIndex = 1
		end

	
	end
	
	if globIsInDemoMode == false then 
		shotSnd:stop()
		shotSnd:play()
	end
	
end

function Boss2.draw(self)

	if self.active then	
		
		lg.draw(self.currentGph, self.x, self.y, 0, 1, 1)
	end
end







