require "luas.shortcuts"
require "luas.extendedLoader"

BossBackground = Object:extend()


function BossBackground.new(self) --, aPosX, aPosY) position only known at activation time
	
	self:reset() --lots of other values initialized here and also reset to defaults on deactivation

end


function BossBackground:reset()

	self.active = false	
	
	self.currentGph  = nil
	
	self.x = 0
	self.y = 0
	
	self.startPosX = 0 
	self.startPosY = 0
	
	self.moveCounter = 0
	
	self.toggleVisible = false
	
end

function BossBackground.putStartPosition(self, aPx, aPy)

	self.x = aPx
	self.y = aPy
	
	self.startPosX = aPx 
	self.startPosY = aPy
end

function BossBackground.activate(self)
	
	self.active = true
	
	self.currentGph = enmBossBackGph
	
	self.moveCounter = 200
	
	self.toggleVisible = true
	
end

function BossBackground.deactivate(self)

	--self.active = false --is not enough, will cause carry-over of behaviors such as matrix/roaming mode
	
	--clean it up on deactivation
	self:reset()
end

function BossBackground.doUpdate(self)
	
	--only if still active
	if self.active == true then
		self.executeFlyMove(self) --always as long as active: move along the x axis
	end
end


function BossBackground.executeFlyMove(self)

	--scrolling movement pixel
	if self.moveCounter > 0 then
		self.moveCounter = self.moveCounter - 1
		self.x = self.x - 1
	end
	
	if self.toggleVisible == true then
		self.toggleVisible = false
	else
		self.toggleVisible = true
	end
	
end


function BossBackground.draw(self)

	if self.active then	
		if self.toggleVisible == true then
			lg.draw(self.currentGph, self.x, self.y, 0, 1, 1)
		end
	end
end







