
require "luas.shortcuts"
require "luas.extendedLoader"


--HOT TODOS extended loader (enemy bounding box) -> DONE
--          globals: enemy container structure --
--          game + demo mode loading level (?) + enemy from level pictures + activate in container

ExplosionBoss1 = Object:extend()

function ExplosionBoss1.new(self)

	self.active = false
	
	self.x = 0
	self.y = 0

	self.frames = {}
	
	self.anmStep       = 3 --use for index of frame (here set invalid)
	self.anmThresh     = 2
	
	self.timer = 0
	
	self.subExplosionOriginX = 0
	self.subExplosionOriginY = 0
	self.subExplosionRangeX = 0
	self.subExplosionRangeY = 0
	self.subExplosionTimer = 0
	self.subExplosionTimerMax = 15

end

function ExplosionBoss1.activate(self, aPX, aPY)

	self.active = true

	self.x = aPX
	self.y = aPY
	self.anmStep = 1
	
	self.frames[1] = enmBoss1Gph
	self.frames[2] = enmBossEmpty1Gph

	self.timer = 120
	
	self.subExplosionOriginX = self.x - 20
	self.subExplosionOriginY = self.y - 20
	self.subExplosionRangeX = 50
	self.subExplosionRangeY = 50
	
	self.subExplosionTimer = self.subExplosionTimerMax
	
end

function ExplosionBoss1.deactivate(self)

	self.active = false

	self.x = 0
	self.y = 0
	--self.explIndex = 0 --TODO that's inconsistent/Bug as self.explIndex doesnt exist elsewhere in this class/(at all?)
end

function ExplosionBoss1.doUpdate(self)

	if self.active then
		
		self.anmStep = self.anmStep + 1
	
		if self.anmStep > self.anmThresh then
			self.anmStep = 1
		end
		
		self.timer = self.timer - 1
		
		self.subExplosionTimer = self.subExplosionTimer - 1
		if self.subExplosionTimer <= 0 then
			self.subExplosionTimer = self.subExplosionTimerMax
			self.plantSubExplosion(self)
		end
		
		if self.timer <= 0 then
			self.deactivate(self)
			
			if globIsInDemoMode == false then
				bigExplosionSnd:stop()
				bigExplosionSnd:play()
			end
		end 
	end
end

function ExplosionBoss1.plantSubExplosion(self)
	
	local lclPosX = self.subExplosionOriginX + love.math.random(self.subExplosionRangeX)
	local lclPosY = self.subExplosionOriginY + love.math.random(self.subExplosionRangeY)
	local lclMediumBig = love.math.random(100)
	
	if lclMediumBig <= 50 then
		globMediumExplosions[globMediumExplosionIndex].activate(globMediumExplosions[globMediumExplosionIndex], lclPosX, lclPosY)
		globMediumExplosionIndex = globMediumExplosionIndex + 1
		if globMediumExplosionIndex > globMediumExplosionMax then
			globMediumExplosionIndex = 1
		end
	else
		globBigExplosions[globBigExplosionIndex].activate(globBigExplosions[globBigExplosionIndex], lclPosX, lclPosY)
		globBigExplosionIndex = globBigExplosionIndex + 1
		if globBigExplosionIndex > globBigExplosionMax then
			globBigExplosionIndex = 1
		end
	end
	
	if globIsInDemoMode == false then
		explosionSeriesSnd:stop()
		explosionSeriesSnd:play()
		enemyDie9Snd:stop()
		enemyDie9Snd:play()
	end

end

function ExplosionBoss1.draw(self)
	if self.active then
		lg.draw(self.frames[self.anmStep], self.x, self.y, 0, 1, 1)
	end
end


