
require "luas.shortcuts"
require "luas.extendedLoader"


--HOT TODOS extended loader (enemy bounding box) -> DONE
--          globals: enemy container structure --
--          game + demo mode loading level (?) + enemy from level pictures + activate in container

ExplosionMothership = Object:extend()

function ExplosionMothership.new(self)

	self.active = false
	
	self.x = 0
	self.y = 0

	self.frames = {}
	
	self.anmStep       = 3 --use for index of frame (here set invalid)
	self.anmThresh     = 2
	
	self.timer = 0
	
	self.subExplosionOriginX = 0
	self.subExplosionOriginY = 0
	self.subExplosionRangeX = 0
	self.subExplosionRangeY = 0
	self.subExplosionTimer = 0
	self.subExplosionTimerMax = 15
	
	self.delayTimer = 0
	self.delayTimerMax = 200

end

function ExplosionMothership.activate(self, aPX, aPY)

	self.active = true

	self.x = aPX
	self.y = aPY
	self.anmStep = 1
	
	self.frames[1] = motherShipGph
	self.frames[2] = motherShipEmptyGph

	self.timer = 120
	
	self.subExplosionOriginX = self.x - 11
	self.subExplosionOriginY = self.y - 11
	self.subExplosionRangeX = 35
	self.subExplosionRangeY = 35
	
	self.subExplosionTimer = self.subExplosionTimerMax
	
	self.delayTimer = self.delayTimerMax 
	
end

function ExplosionMothership.deactivate(self)

	self.active = false

	self.x = 0
	self.y = 0
	--self.explIndex = 0 --TODO that's inconsistent/Bug as self.explIndex doesnt exist elsewhere in this class/(at all?)
end

function ExplosionMothership.doUpdate(self)

	if self.active then
		
		
		if self.delayTimer > 0 then
			self.delayTimer = self.delayTimer - 1
		else
			self.anmStep = self.anmStep + 1
	
			if self.anmStep > self.anmThresh then
				self.anmStep = 1
			end
		
			self.timer = self.timer - 1
		
			self.subExplosionTimer = self.subExplosionTimer - 1
			if self.subExplosionTimer <= 0 then
				self.subExplosionTimer = self.subExplosionTimerMax
				self.plantSubExplosion(self)
			end
		
			if self.timer <= 0 then
				self.deactivate(self)
				
				if globIsInDemoMode == false then
					bigExplosionSnd:stop()
					bigExplosionSnd:play()
				end
			end 
		
		end
	end
end

function ExplosionMothership.plantSubExplosion(self)
	
	local lclPosX = self.subExplosionOriginX + love.math.random(self.subExplosionRangeX)
	local lclPosY = self.subExplosionOriginY + love.math.random(self.subExplosionRangeY)
	local lclSmallMedium = love.math.random(100)
	
	if lclSmallMedium <= 50 then
		globSmallExplosions[globSmallExplosionIndex].activate(globSmallExplosions[globSmallExplosionIndex], lclPosX, lclPosY)
		globSmallExplosionIndex = globSmallExplosionIndex + 1
		if globSmallExplosionIndex > globSmallExplosionMax then
			globSmallExplosionIndex = 1
		end
	else
		globMediumExplosions[globMediumExplosionIndex].activate(globMediumExplosions[globMediumExplosionIndex], lclPosX, lclPosY)
		globMediumExplosionIndex = globMediumExplosionIndex + 1
		if globMediumExplosionIndex > globMediumExplosionMax then
			globMediumExplosionIndex = 1
		end
	end
	
	if globIsInDemoMode == false then
		explosionSeriesSnd:stop()
		explosionSeriesSnd:play()
		enemyDie9Snd:stop()
		enemyDie9Snd:play()
	end

end

function ExplosionMothership.draw(self)
	if self.active then
		lg.draw(self.frames[self.anmStep], self.x, self.y, 0, 1, 1)
	end
end


