require "luas.helpers"
require "luas.shortcuts"
																										--Task AAG (part 2) load game graphics
function loadLevelContents()

	backGroundGph    = lg.newImage("gfx/Levels/Background.png")
	backGroundGph:setFilter("nearest","nearest")
	
	dat = backGroundGph:getData()
	dat:mapPixel( makeOpaquePink )
	backGroundGph:refresh()


end

function loadPlayerSprites()

	playerShipGph={}
	
	--for i=1,globMaxPlayers,1 do --can't access maxplayers from globals. globals are set up with extendedloader
	                              --not the other way round
	for i=1,1,1 do--only 1 player
		playerShipGph[i] = {}    
		
		for j = 1,2,1 do --playership has 2 frames
		playerShipGph[i][j] = lg.newImage("gfx/Ship/PlayerShip_"..i.."_"..j..".png")
		playerShipGph[i][j]:setFilter("nearest","nearest")
	
		dat = playerShipGph[i][j]:getData()
		dat:mapPixel( makeOpaquePink )
		playerShipGph[i][j]:refresh()
		end
	
	end
	
		--boundingbox for collision
	shipBoxGph = lg.newImage("gfx/Ship/ShipBox.png")
	shipBoxGph:setFilter("nearest","nearest")
	
	--like a boundingbox for mouse movement
	mouseBoxGph = lg.newImage("gfx/Ship/MouseBox.png")
	mouseBoxGph:setFilter("nearest","nearest")
	
	playerShotGph = {}
	for i=1,1,1 do --only 1 players
		playerShotGph[i] = {}
		
		for j = 1,4,1 do
			playerShotGph[i][j]    = lg.newImage("gfx/Ship/PlayerShot_"..i.."_"..j..".png")
			playerShotGph[i][j]:setFilter("nearest","nearest")
	
			dat = playerShotGph[i][j]:getData()
			dat:mapPixel( makeOpaquePink )
			playerShotGph[i][j]:refresh()
		end
	end
	
	playerShotBoxGph = lg.newImage("gfx/Ship/PlayerShotBox.png")
	playerShotBoxGph:setFilter("nearest","nearest")
	
	
	sateliteGph = lg.newImage("gfx/Ship/Satelite.png")
	sateliteGph:setFilter("nearest","nearest")
	
	dat = sateliteGph:getData()
	dat:mapPixel( makeOpaquePink )
	sateliteGph:refresh()
	
	
	playerExplodeGph ={}
	
	for i=1,2,1 do
		playerExplodeGph[i] = lg.newImage("gfx/Ship/PlayerExplode_"..i..".png")
		playerExplodeGph[i]:setFilter("nearest","nearest")
		
		dat = playerExplodeGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		playerExplodeGph[i]:refresh()
	end

end

function loadEnemySprites()

	enmAGph = lg.newImage("gfx/Enemies/Enm_A.png")
	enmAGph:setFilter("nearest","nearest")
	
	dat = enmAGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmAGph:refresh()
	
	enmBGph = {}
	
	for i = 1,5,1 do
		enmBGph[i] = lg.newImage("gfx/Enemies/Enm_B_"..i..".png")
		enmBGph[i]:setFilter("nearest","nearest")
		
		dat = enmBGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmBGph[i]:refresh()
	end
	
	enmCGph = {}
	
	for i = 1,4,1 do
		enmCGph[i] = lg.newImage("gfx/Enemies/Enm_C_"..i..".png")
		enmCGph[i]:setFilter("nearest","nearest")
		
		dat = enmCGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmCGph[i]:refresh()
	end
	
	enmDGph = {}
	
	for i = 1,5,1 do
		enmDGph[i] = lg.newImage("gfx/Enemies/Enm_D_"..i..".png")
		enmDGph[i]:setFilter("nearest","nearest")
		
		dat = enmDGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmDGph[i]:refresh()
	end
	
	enmEGph = {}
	
	for i = 1,7,1 do
		enmEGph[i] = lg.newImage("gfx/Enemies/Enm_E_"..i..".png")
		enmEGph[i]:setFilter("nearest","nearest")
		
		dat = enmEGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmEGph[i]:refresh()
	end
	
	enmFGph = {}
	
	for i = 1,7,1 do
		enmFGph[i] = lg.newImage("gfx/Enemies/Enm_F_"..i..".png")
		enmFGph[i]:setFilter("nearest","nearest")
		
		dat = enmFGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmFGph[i]:refresh()
	end
	
	enmGGph = lg.newImage("gfx/Enemies/Enm_G.png")
	enmGGph:setFilter("nearest","nearest")
	
	dat = enmGGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmGGph:refresh()
	
	enmHGph = lg.newImage("gfx/Enemies/Enm_H.png")
	enmHGph:setFilter("nearest","nearest")
	
	dat = enmHGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmHGph:refresh()
	
	enmIGph = lg.newImage("gfx/Enemies/Enm_I.png")
	enmIGph:setFilter("nearest","nearest")
	
	dat = enmIGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmIGph:refresh()
	
	enmJGph = lg.newImage("gfx/Enemies/Enm_J.png")
	enmJGph:setFilter("nearest","nearest")
	
	dat = enmJGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmJGph:refresh()
	
	enmKGph = lg.newImage("gfx/Enemies/Enm_K.png")
	enmKGph:setFilter("nearest","nearest")
	
	dat = enmKGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmKGph:refresh()
	
	
	enmLGph = {}
	
	for i = 1,2,1 do
		enmLGph[i] = lg.newImage("gfx/Enemies/Enm_L_"..i..".png")
		enmLGph[i]:setFilter("nearest","nearest")
		
		dat = enmLGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmLGph[i]:refresh()
	end
	
	enmMGph = lg.newImage("gfx/Enemies/Enm_M.png")
	enmMGph:setFilter("nearest","nearest")
	
	dat = enmMGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmMGph:refresh()
	
	
	enmNGph = {}
	
	for i = 1,4,1 do
		enmNGph[i] = lg.newImage("gfx/Enemies/Enm_N_"..i..".png")
		enmNGph[i]:setFilter("nearest","nearest")
		
		dat = enmNGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmNGph[i]:refresh()
	end
	
		
	enmOGph = {}
	
	for i = 1,5,1 do
		enmOGph[i] = lg.newImage("gfx/Enemies/Enm_O_"..i..".png")
		enmOGph[i]:setFilter("nearest","nearest")
		
		dat = enmOGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmOGph[i]:refresh()
	end
	
	
	enmPGph = lg.newImage("gfx/Enemies/Enm_P.png")
	enmPGph:setFilter("nearest","nearest")
	
	dat = enmPGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmPGph:refresh()
	
	enmQGph = lg.newImage("gfx/Enemies/Enm_Q.png")
	enmQGph:setFilter("nearest","nearest")
	
	dat = enmQGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmQGph:refresh()
	
	enmRGph = lg.newImage("gfx/Enemies/Enm_R.png")
	enmRGph:setFilter("nearest","nearest")
	
	dat = enmRGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmRGph:refresh()
	
	enmSGph = lg.newImage("gfx/Enemies/Enm_S.png")
	enmSGph:setFilter("nearest","nearest")
	
	dat = enmSGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmSGph:refresh()
	
	
	enmTGph = {}
	
	for i = 1,4,1 do
		enmTGph[i] = lg.newImage("gfx/Enemies/Enm_T_"..i..".png")
		enmTGph[i]:setFilter("nearest","nearest")
		
		dat = enmTGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmTGph[i]:refresh()
	end
	
	enmUGph = lg.newImage("gfx/Enemies/Enm_U.png")
	enmUGph:setFilter("nearest","nearest")
	
	dat = enmUGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmUGph:refresh()
	
	
	enmVGph = {}
	
	for i = 1,2,1 do
		enmVGph[i] = lg.newImage("gfx/Enemies/Enm_V_"..i..".png")
		enmVGph[i]:setFilter("nearest","nearest")
		
		dat = enmVGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmVGph[i]:refresh()
	end
	
	enmWGph = lg.newImage("gfx/Enemies/Enm_W.png")
	enmWGph:setFilter("nearest","nearest")
	
	dat = enmWGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmWGph:refresh()
	
	enmXGph = lg.newImage("gfx/Enemies/Enm_X.png")
	enmXGph:setFilter("nearest","nearest")
	
	dat = enmXGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmXGph:refresh()
	
	
	enmYGph = {}
	
	for i = 1,2,1 do
		enmYGph[i] = lg.newImage("gfx/Enemies/Enm_Y_"..i..".png")
		enmYGph[i]:setFilter("nearest","nearest")
		
		dat = enmYGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmYGph[i]:refresh()
	end
	
	
	enmZGph = {}
	
	for i = 1,2,1 do
		enmZGph[i] = lg.newImage("gfx/Enemies/Enm_Z_"..i..".png")
		enmZGph[i]:setFilter("nearest","nearest")
		
		dat = enmZGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmZGph[i]:refresh()
	end
	
	
	
	
	enmBoss1Gph = lg.newImage("gfx/Enemies/Boss_1.png")
	enmBoss1Gph:setFilter("nearest","nearest")
	
	dat = enmBoss1Gph:getData()
	dat:mapPixel( makeOpaquePink )
	enmBoss1Gph:refresh()
	
	enmBossEmpty1Gph = lg.newImage("gfx/Enemies/Boss_Empty_1.png")
	enmBossEmpty1Gph:setFilter("nearest","nearest")
	
	dat = enmBossEmpty1Gph:getData()
	dat:mapPixel( makeOpaquePink )
	enmBossEmpty1Gph:refresh()
	
	
	enmBoss2Gph = lg.newImage("gfx/Enemies/Boss_2.png")
	enmBoss2Gph:setFilter("nearest","nearest")
	
	dat = enmBoss2Gph:getData()
	dat:mapPixel( makeOpaquePink )
	enmBoss2Gph:refresh()
	
	enmBossEmpty2Gph = lg.newImage("gfx/Enemies/Boss_Empty_2.png")
	enmBossEmpty2Gph:setFilter("nearest","nearest")
	
	dat = enmBossEmpty2Gph:getData()
	dat:mapPixel( makeOpaquePink )
	enmBossEmpty2Gph:refresh()
	
	
	
	enmBoss3Gph = lg.newImage("gfx/Enemies/Boss_3.png")
	enmBoss3Gph:setFilter("nearest","nearest")
	
	dat = enmBoss3Gph:getData()
	dat:mapPixel( makeOpaquePink )
	enmBoss3Gph:refresh()
	
	enmBossEmpty3Gph = lg.newImage("gfx/Enemies/Boss_Empty_3.png")
	enmBossEmpty3Gph:setFilter("nearest","nearest")
	
	dat = enmBossEmpty3Gph:getData()
	dat:mapPixel( makeOpaquePink )
	enmBossEmpty3Gph:refresh()
	
	
	
	enmBossBackGph = lg.newImage("gfx/Enemies/BossBack.png")
	enmBossBackGph:setFilter("nearest","nearest")
	
	dat = enmBossBackGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmBossBackGph:refresh()
	
	
	
	enmShotAGph = lg.newImage("gfx/Enemies/EnmShot_A.png")
	enmShotAGph:setFilter("nearest","nearest")
	
	dat = enmShotAGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmShotAGph:refresh()
	
	enmShotABoxGph = lg.newImage("gfx/Enemies/EnmShot_A_Box.png")
	enmShotABoxGph:setFilter("nearest","nearest")
	
	
	
	enmShotBGph = lg.newImage("gfx/Enemies/EnmShot_B.png")
	enmShotBGph:setFilter("nearest","nearest")
	
	dat = enmShotBGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmShotBGph:refresh()
	
	enmShotBBoxGph = lg.newImage("gfx/Enemies/EnmShot_B_Box.png")
	enmShotBBoxGph:setFilter("nearest","nearest")
	
	
	
	enmShotCGph = lg.newImage("gfx/Enemies/EnmShot_C.png")
	enmShotCGph:setFilter("nearest","nearest")
	
	dat = enmShotCGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmShotCGph:refresh()
	
	enmShotCBoxGph = lg.newImage("gfx/Enemies/EnmShot_C_Box.png")
	enmShotCBoxGph:setFilter("nearest","nearest")
	
	
	
	enmShotDGph = lg.newImage("gfx/Enemies/EnmShot_D.png")
	enmShotDGph:setFilter("nearest","nearest")
	
	dat = enmShotDGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmShotDGph:refresh()
	
	enmShotDBoxGph = lg.newImage("gfx/Enemies/EnmShot_D_Box.png")
	enmShotDBoxGph:setFilter("nearest","nearest")
	
	
	
	enmShotEGph = lg.newImage("gfx/Enemies/EnmShot_E.png")
	enmShotEGph:setFilter("nearest","nearest")
	
	dat = enmShotEGph:getData()
	dat:mapPixel( makeOpaquePink )
	enmShotEGph:refresh()
	
	enmShotEBoxGph = lg.newImage("gfx/Enemies/EnmShot_E_Box.png")
	enmShotEBoxGph:setFilter("nearest","nearest")
	
	
	enmShotFGph = {}
	
	for i=1,4,1 do
	
		enmShotFGph[i] = lg.newImage("gfx/Enemies/EnmShot_F_"..i..".png")
		enmShotFGph[i]:setFilter("nearest","nearest")
	
		dat = enmShotFGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmShotFGph[i]:refresh()
	
	end
	
	enmShotFBoxGph = lg.newImage("gfx/Enemies/EnmShot_F_Box.png")
	enmShotFBoxGph:setFilter("nearest","nearest")
	
	
	
	enmExplodeSmallGph = {}
	for i=1,4,1 do

		enmExplodeSmallGph[i] = lg.newImage("gfx/Enemies/ExplodeSmall_"..i..".png")
		enmExplodeSmallGph[i]:setFilter("nearest","nearest")
			
		dat = enmExplodeSmallGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmExplodeSmallGph[i]:refresh()
	end
	
	enmExplodeMediumGph = {}
	for i=1,4,1 do

		enmExplodeMediumGph[i] = lg.newImage("gfx/Enemies/ExplodeMedium_"..i..".png")
		enmExplodeMediumGph[i]:setFilter("nearest","nearest")
			
		dat = enmExplodeMediumGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmExplodeMediumGph[i]:refresh()
	end
	
	enmExplodeBigGph = {}
	for i=1,4,1 do
		enmExplodeBigGph[i] = lg.newImage("gfx/Enemies/ExplodeBig_"..i..".png")
		enmExplodeBigGph[i]:setFilter("nearest","nearest")
			
		dat = enmExplodeBigGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmExplodeBigGph[i]:refresh()
	end
	
	enmExplode1000Gph = {}
	for i=1,2,1 do

		enmExplode1000Gph[i] = lg.newImage("gfx/Enemies/Explode1000_"..i..".png")
		enmExplode1000Gph[i]:setFilter("nearest","nearest")
			
		dat = enmExplode1000Gph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		enmExplode1000Gph[i]:refresh()
	end
	
	
	
	
end

function loadLevelGphs()

	levelIntroGphs = {}
	levelForegroundGphs = {}
	levelGphs = {}
	
	for i = 1,3,1 do
	
		levelIntroGphs[i] = lg.newImage("gfx/Levels/IntroLv_"..i..".png")
		levelIntroGphs[i]:setFilter("nearest","nearest")
	
		levelForegroundGphs[i] = lg.newImage("gfx/Levels/ForegroundLv_"..i..".png")
		levelForegroundGphs[i]:setFilter("nearest","nearest")
		
		dat = levelForegroundGphs[i]:getData()
		dat:mapPixel( makeOpaquePink )
		levelForegroundGphs[i]:refresh()
		
		levelGphs[i] = lg.newImage("gfx/Levels/Level_"..i..".png")
		levelGphs[i]:setFilter("nearest","nearest")
	end
	
	--have placeholder foreground for level 4 cause at ending globLevel will be set to 4 and if no foreground is available the game will crash
	
	levelForegroundGphs[4] = lg.newImage("gfx/Levels/ForegroundLv_4.png")
	levelForegroundGphs[4]:setFilter("nearest","nearest")
		
	dat = levelForegroundGphs[4]:getData()
	dat:mapPixel( makeOpaquePink )
	levelForegroundGphs[4]:refresh()
	
	--same goes for introgph
	levelIntroGphs[4] = lg.newImage("gfx/Levels/IntroLv_4.png")
	levelIntroGphs[4]:setFilter("nearest","nearest")
	
	dat = levelIntroGphs[4]:getData()
	dat:mapPixel( makeOpaquePink )
	levelIntroGphs[4]:refresh()

end

function loadProjectileSprites()
	
end


function loadMiscSprites()

	powerupGph = {}
	
	for i = 1,2,1 do
		powerupGph[i] = {}
		
		for j = 1,2,1 do
			powerupGph[i][j] = lg.newImage("gfx/Misc/Powerup"..i.."_"..j..".png")
			powerupGph[i][j]:setFilter("nearest","nearest")
			
			dat = powerupGph[i][j]:getData()
			dat:mapPixel( makeOpaquePink )
			powerupGph[i][j]:refresh()
		end
	end
	
	sateliteCollectibleGph = {}
	
	for i = 1,2,1 do
		sateliteCollectibleGph[i] = lg.newImage("gfx/Misc/SateliteCollectible_"..i..".png")
		sateliteCollectibleGph[i]:setFilter("nearest","nearest")
			
		dat = sateliteCollectibleGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		sateliteCollectibleGph[i]:refresh()
	end


end

function loadSymbols()

	digitGph={}
	
	for i=1,10,1 do
		local dNum = i-1
		digitGph[i]= lg.newImage("gfx/Symbol/D_".. dNum ..".png")
		digitGph[i]:setFilter("nearest","nearest")
		
		dat = digitGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		digitGph[i]:refresh()
	end
	

	extraSymbolGph = lg.newImage("gfx/Symbol/ExtraLife.png")
	extraSymbolGph:setFilter("nearest","nearest")
	dat = extraSymbolGph:getData()
	dat:mapPixel( makeOpaquePink )
	extraSymbolGph:refresh()


end

function loadOverlays()

	gameLogoGph = lg.newImage("gfx/Overlay/GameLogo.png")
	gameLogoGph:setFilter("nearest","nearest")
	dat = gameLogoGph:getData()
	dat:mapPixel( makeOpaquePink )
	gameLogoGph:refresh()
	
	cursorGph = lg.newImage("gfx/Overlay/Cursor.png")
	cursorGph:setFilter("nearest","nearest")
	dat = cursorGph:getData()
	dat:mapPixel( makeOpaquePink )
	cursorGph:refresh()
	
	pauseGph = lg.newImage("gfx/Overlay/Pause.png")
	pauseGph:setFilter("nearest","nearest")
	dat = pauseGph:getData()
	dat:mapPixel( makeOpaquePink )
	pauseGph:refresh()
	
	gameOverOverlayGph = lg.newImage("gfx/Overlay/GameOver.png")
	gameOverOverlayGph:setFilter("nearest","nearest")
	dat = gameOverOverlayGph:getData()
	dat:mapPixel( makeOpaquePink )
	gameOverOverlayGph:refresh()
	
	motherShipGph = lg.newImage("gfx/Overlay/Mothership.png")
	motherShipGph:setFilter("nearest","nearest")
	dat = motherShipGph:getData()
	dat:mapPixel( makeOpaquePink )
	motherShipGph:refresh()
	
	motherShipEmptyGph = lg.newImage("gfx/Overlay/Mothership_Empty.png")
	motherShipEmptyGph:setFilter("nearest","nearest")
	dat = motherShipEmptyGph:getData()
	dat:mapPixel( makeOpaquePink )
	motherShipEmptyGph:refresh()
	
	smallShipGph = lg.newImage("gfx/Overlay/SmallShip.png")
	smallShipGph:setFilter("nearest","nearest")
	dat = smallShipGph:getData()
	dat:mapPixel( makeOpaquePink )
	smallShipGph:refresh()
	
	finalScoreGph = lg.newImage("gfx/Overlay/FinalScore.png")
	finalScoreGph:setFilter("nearest","nearest")
	dat = finalScoreGph:getData()
	dat:mapPixel( makeOpaquePink )
	finalScoreGph:refresh()
	
	theEndGph = lg.newImage("gfx/Overlay/TheEnd.png")
	theEndGph:setFilter("nearest","nearest")
	dat = theEndGph:getData()
	dat:mapPixel( makeOpaquePink )
	theEndGph:refresh()
	
	difficultyGph = {}
	for i = 1,3,1 do
		difficultyGph[i] = lg.newImage("gfx/Overlay/Difficulty_"..i..".png")
		difficultyGph[i]:setFilter("nearest","nearest")
		dat = difficultyGph[i]:getData()
		dat:mapPixel( makeOpaquePink )
		difficultyGph[i]:refresh()
	end
	
	commentGph = {}
	
	for i = 1,4,1 do
	
		commentGph[i] = {}
		
		for j = 1,4,1 do
			commentGph[i][j] = lg.newImage("gfx/Overlay/Comment_"..i.."_"..j..".png")
			commentGph[i][j]:setFilter("nearest","nearest")
			dat = commentGph[i][j]:getData()
			dat:mapPixel( makeOpaquePink )
			commentGph[i][j]:refresh()
		end
	end
	
	
	
	
end

																										--Task AAH (part 2) load sound

function loadMp3()

	titleMusic  = love.audio.newSource("sfx/Titlescreen.ogg", "stream")
	level1Music = love.audio.newSource("sfx/Level1.ogg", "stream")
	level2Music = love.audio.newSource("sfx/Level2.ogg", "stream")
	level3Music = love.audio.newSource("sfx/Level3.ogg", "stream")
	bossMusic   = love.audio.newSource("sfx/BossEnemy.ogg", "stream")
	endingMusic = love.audio.newSource("sfx/Ending.ogg", "stream")
	--
	titleMusic:setVolume(1.0)
	level1Music:setVolume(1.0)
	level2Music:setVolume(1.0)
	level3Music:setVolume(1.0)
	bossMusic:setVolume(1.0)
	endingMusic:setVolume(1.0)
	--
	titleMusic:setLooping(true)
	level1Music:setLooping(true)
	level2Music:setLooping(true)
	level3Music:setLooping(true)
	bossMusic:setLooping(true)
	endingMusic:setLooping(true)
	
	levelIntroMusic = love.audio.newSource("sfx/LevelIntro.wav", "static") 
	gameOverMusic   = love.audio.newSource("sfx/GameOver.wav", "static") 
	--
	levelIntroMusic:setVolume(1.0)
	gameOverMusic:setVolume(1.0)
end


function loadSfx()

	shipShotSnd             = love.audio.newSource("sfx/ShipShot.wav", "static")
	extraLifeSnd            = love.audio.newSource("sfx/ExtraLife.wav", "static")
	pauseSnd                = love.audio.newSource("sfx/Pause.wav", "static")
	enemyHitSnd             = love.audio.newSource("sfx/EnemyHit.wav", "static")
	enemyHit2Snd            = love.audio.newSource("sfx/EnemyHit2.wav", "static")
	bossHitSnd              = love.audio.newSource("sfx/BossHit.wav", "static")
	shotSnd                 = love.audio.newSource("sfx/Shot.wav", "static") 
	playerExplosionSnd      = love.audio.newSource("sfx/PlayerExplosion.wav", "static")
	extraPowerSnd           = love.audio.newSource("sfx/ExtraPower.wav", "static")
	explosionSeriesSnd      = love.audio.newSource("sfx/ExplosionSeries.wav", "static")
	enemyDie1Snd            = love.audio.newSource("sfx/EnemyDie1.wav", "static")
	enemyDie2Snd            = love.audio.newSource("sfx/EnemyDie2.wav", "static")
	enemyDie3Snd            = love.audio.newSource("sfx/EnemyDie3.wav", "static")
	enemyDie4Snd            = love.audio.newSource("sfx/EnemyDie4.wav", "static")
	enemyDie5Snd            = love.audio.newSource("sfx/EnemyDie5.wav", "static")
	enemyDie6Snd            = love.audio.newSource("sfx/EnemyDie6.wav", "static")
	enemyDie7Snd            = love.audio.newSource("sfx/EnemyDie7.wav", "static")
	enemyDie8Snd            = love.audio.newSource("sfx/EnemyDie8.wav", "static")
	enemyDie9Snd            = love.audio.newSource("sfx/EnemyDie9.wav", "static")
	enemyDie10Snd           = love.audio.newSource("sfx/EnemyDie10.wav", "static")
	enemyDie11Snd           = love.audio.newSource("sfx/EnemyDie11.wav", "static")
	escapeSnd               = love.audio.newSource("sfx/Escape.wav", "static")
	bigExplosionSnd         = love.audio.newSource("sfx/BigExplosion.wav", "static")
	
	shipShotSnd:setVolume(0.075)
	extraLifeSnd:setVolume(0.6)
	pauseSnd:setVolume(0.75)
	enemyHitSnd:setVolume(0.75)
	enemyHit2Snd:setVolume(0.65)
	bossHitSnd:setVolume(0.48)
	shotSnd:setVolume(0.3)
	playerExplosionSnd:setVolume(0.35)
	extraPowerSnd:setVolume(0.5)
	explosionSeriesSnd:setVolume(0.6)
	enemyDie1Snd:setVolume(0.3)
	enemyDie2Snd:setVolume(0.4)
	enemyDie3Snd:setVolume(0.5)
	enemyDie4Snd:setVolume(1.0)
	enemyDie5Snd:setVolume(0.9)
	enemyDie6Snd:setVolume(0.7)
	enemyDie7Snd:setVolume(0.5)
	enemyDie8Snd:setVolume(0.3)
	enemyDie9Snd:setVolume(0.6)
	enemyDie10Snd:setVolume(0.5)
	enemyDie11Snd:setVolume(0.4)
	escapeSnd:setVolume(0.5)
	bigExplosionSnd:setVolume(0.35)

	
end




