require "luas.shortcuts"

MaskPrinter = Object:extend()

function MaskPrinter.new(self)

	self.setConsts(self)
	
	self.numPlayerLifes      = 0
	
	self.valScore            = 0


end

function MaskPrinter.setConsts(self)

	MASK_LINE_SCORE_Y  = 138 - 1
	MASK_LINE_LIFES_Y  = MASK_LINE_SCORE_Y
	
	MASK_OFFSET_DIGITSYMBOL = 6 --1 pixel fallacy does not apply to distances
	MASK_OFFSET_SHIPSYMBOL  = 8
	
	
	MASK_PL_SHIP_PX = {}
	MASK_PL_SHIP_PY = {}
	
	MASK_PL_SHIP_PX[1] = 9 - 1
	MASK_PL_SHIP_PX[2] = MASK_PL_SHIP_PX[1] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[3] = MASK_PL_SHIP_PX[2] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[4] = MASK_PL_SHIP_PX[3] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[5] = MASK_PL_SHIP_PX[4] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[6] = MASK_PL_SHIP_PX[5] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[7] = MASK_PL_SHIP_PX[6] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[8] = MASK_PL_SHIP_PX[7] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[9] = MASK_PL_SHIP_PX[8] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[10] = MASK_PL_SHIP_PX[9] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[11] = MASK_PL_SHIP_PX[10] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[12] = MASK_PL_SHIP_PX[11] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[13] = MASK_PL_SHIP_PX[12] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[14] = MASK_PL_SHIP_PX[13] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[15] = MASK_PL_SHIP_PX[14] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[16] = MASK_PL_SHIP_PX[15] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[17] = MASK_PL_SHIP_PX[16] + MASK_OFFSET_SHIPSYMBOL
	MASK_PL_SHIP_PX[18] = MASK_PL_SHIP_PX[17] + MASK_OFFSET_SHIPSYMBOL
	--
	MASK_PL_SHIP_PY[1] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[2] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[3] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[4] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[5] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[6] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[7] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[8] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[9] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[10] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[11] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[12] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[13] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[14] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[15] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[16] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[17] = MASK_LINE_LIFES_Y
	MASK_PL_SHIP_PY[18] = MASK_LINE_LIFES_Y
	
	--positions for scoredigits
	MASK_SCORE_DIGIT_PX = {}
	MASK_SCORE_DIGIT_PY = {}
	--
	MASK_SCORE_DIGIT_PX[1] = 190 - 1
	MASK_SCORE_DIGIT_PX[2] = MASK_SCORE_DIGIT_PX[1] - MASK_OFFSET_DIGITSYMBOL
	MASK_SCORE_DIGIT_PX[3] = MASK_SCORE_DIGIT_PX[2] - MASK_OFFSET_DIGITSYMBOL
	MASK_SCORE_DIGIT_PX[4] = MASK_SCORE_DIGIT_PX[3] - MASK_OFFSET_DIGITSYMBOL
	MASK_SCORE_DIGIT_PX[5] = MASK_SCORE_DIGIT_PX[4] - MASK_OFFSET_DIGITSYMBOL
	MASK_SCORE_DIGIT_PX[6] = MASK_SCORE_DIGIT_PX[5] - MASK_OFFSET_DIGITSYMBOL
	MASK_SCORE_DIGIT_PX[7] = MASK_SCORE_DIGIT_PX[6] - MASK_OFFSET_DIGITSYMBOL
	--
	MASK_SCORE_DIGIT_PY[1] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[2] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[3] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[4] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[5] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[6] = MASK_LINE_SCORE_Y
	MASK_SCORE_DIGIT_PY[7] = MASK_LINE_SCORE_Y
	


end

function MaskPrinter.doUpdate(self)

	self.numPlayerLifes = globNumLifes[1]
	if self.numPlayerLifes < 0 then --globals define negative values for lifes (gameover =(-1),not joined = (-2))
		self.numPlayerLifes = 0     --for printing ignore those and treat like 0 lifes to print
	end
	
	self.valScore            = globScore
	
end


function MaskPrinter.draw(self)


	--if aDemoFlag == false then --in this game print lifes for demo also
	
		self.printExtraLives(self) --TODO restrict for demo
	--end

	self.printScore(self)
	
end


function MaskPrinter.printExtraLives(self)
		
	for i=1,18,1 do -- max 18 lifes extra
		
		if self.numPlayerLifes >= i then--player has that life that is to print next
			
			--take symbol directly from extendedloader
			lg.draw(extraSymbolGph, MASK_PL_SHIP_PX[i], MASK_PL_SHIP_PY[i], 0, 1, 1)
		end
	end
	
end


function MaskPrinter.printScore(self)

	--print score without leading zeros
	sDigit1= self.valScore % 10
	sDigit2= ((self.valScore - sDigit1) % 100) / 10
	sDigit3= ((self.valScore - sDigit2*10 - sDigit1) % 1000) / 100
	sDigit4= ((self.valScore - sDigit3*100 - sDigit2*10 - sDigit1) % 10000) / 1000 
	sDigit5= ((self.valScore - sDigit4*1000 - sDigit3*100 - sDigit2*10 - sDigit1) % 100000) / 10000
	sDigit6= ((self.valScore - sDigit5*10000 - sDigit4*1000 - sDigit3*100 - sDigit2*10 - sDigit1) % 1000000) / 100000 
	sDigit7= ((self.valScore - sDigit6*100000 - sDigit5*10000 - sDigit4*1000 - sDigit3*100 - sDigit2*10 - sDigit1) / 1000000)
		
		
	--always print first digit even when 0
	lg.draw(digitGph[sDigit1 + 1], MASK_SCORE_DIGIT_PX[1], MASK_SCORE_DIGIT_PY[1], 0, 1, 1)
		
	if self.valScore >= 10 then
		lg.draw(digitGph[sDigit2 + 1], MASK_SCORE_DIGIT_PX[2], MASK_SCORE_DIGIT_PY[2], 0, 1, 1)
	end
	if self.valScore >= 100 then
		lg.draw(digitGph[sDigit3 + 1], MASK_SCORE_DIGIT_PX[3], MASK_SCORE_DIGIT_PY[3], 0, 1, 1)
	end
	if self.valScore >= 1000 then
		lg.draw(digitGph[sDigit4 + 1], MASK_SCORE_DIGIT_PX[4], MASK_SCORE_DIGIT_PY[4], 0, 1, 1)
	end
	if self.valScore >= 10000 then
		lg.draw(digitGph[sDigit5 + 1], MASK_SCORE_DIGIT_PX[5], MASK_SCORE_DIGIT_PY[5], 0, 1, 1)
	end
	if self.valScore >= 100000 then
		lg.draw(digitGph[sDigit6 + 1], MASK_SCORE_DIGIT_PX[6], MASK_SCORE_DIGIT_PY[6], 0, 1, 1)
	end
	if self.valScore >= 1000000 then
		lg.draw(digitGph[sDigit7 + 1], MASK_SCORE_DIGIT_PX[7], MASK_SCORE_DIGIT_PY[7], 0, 1, 1)
	end
	
end

