
require "luas.shortcuts"
require "luas.extendedLoader"


--HOT TODOS extended loader (enemy bounding box) -> DONE
--          globals: enemy container structure --
--          game + demo mode loading level (?) + enemy from level pictures + activate in container

PlayerExplosion = Object:extend()

function PlayerExplosion.new(self)

	self.active = false
	
	self.x = 0
	self.y = 0

	self.frames = {}
	
	self.anmStep       = 3 --use for index of frame (here set invalid)
	self.anmThresh     = 2
	
	self.timer = 0
	
	
	self.subExplosionOriginX = 0
	self.subExplosionOriginY = 0
	self.subExplosionRangeX = 0
	self.subExplosionRangeY = 0
	self.subExplosionTimer = 0
	self.subExplosionTimerMax = 10

end

function PlayerExplosion.activate(self, aPX, aPY)

	self.active = true

	self.x = aPX
	self.y = aPY
	self.anmStep = 1
	
	self.frames[1] = playerExplodeGph[1]
	self.frames[2] = playerExplodeGph[2]

	self.timer = 120
	
	
	self.subExplosionOriginX = self.x - 8
	self.subExplosionOriginY = self.y - 8
	self.subExplosionRangeX = 20
	self.subExplosionRangeY = 15
	
	self.subExplosionTimer = self.subExplosionTimerMax
	
end

function PlayerExplosion.deactivate(self)

	self.active = false

	self.x = 0
	self.y = 0
	--self.explIndex = 0 --TODO that's inconsistent/Bug as self.explIndex doesnt exist elsewhere in this class/(at all?)
end

function PlayerExplosion.doUpdate(self)

	if self.active then
		
		self.anmStep = self.anmStep + 1
	
		if self.anmStep > self.anmThresh then
			self.anmStep = 1
		end
		
		self.timer = self.timer - 1
		
		self.subExplosionTimer = self.subExplosionTimer - 1
		if self.subExplosionTimer <= 0 then
			self.subExplosionTimer = self.subExplosionTimerMax
			self.plantSubExplosion(self)
		end
		
		if self.timer <= 0 then
			self.deactivate(self)
		end 
	end
end

function PlayerExplosion.plantSubExplosion(self)

	local lclPosX = self.subExplosionOriginX + love.math.random(self.subExplosionRangeX)
	local lclPosY = self.subExplosionOriginY + love.math.random(self.subExplosionRangeY)

	globSmallExplosions[globSmallExplosionIndex].activate(globSmallExplosions[globSmallExplosionIndex], lclPosX, lclPosY)
	globSmallExplosionIndex = globSmallExplosionIndex + 1
	if globSmallExplosionIndex > globSmallExplosionMax then
		globSmallExplosionIndex = 1
	end
end

function PlayerExplosion.draw(self)
	if self.active then
		lg.draw(self.frames[self.anmStep], self.x, self.y, 0, 1, 1)
	end
end


