require "luas.shortcuts"
require "luas.playerShip"
require "luas.playerBullet"
require "luas.enemyA"
require "luas.enemyB"
require "luas.enemyC"
require "luas.enemyD"
require "luas.enemyE"
require "luas.enemyF"
require "luas.enemyG"
require "luas.enemyH"
require "luas.enemyI"
require "luas.enemyJ"
require "luas.enemyK"
require "luas.enemyL"
require "luas.enemyM"
require "luas.enemyN"
require "luas.enemyO"
require "luas.enemyP"
require "luas.enemyQ"
require "luas.enemyR"
require "luas.enemyS"
require "luas.enemyT"
require "luas.enemyU"
require "luas.enemyV"
require "luas.enemyW"
require "luas.enemyX"
require "luas.enemyY"
require "luas.enemyZ"
require "luas.boss1"
require "luas.boss2"
require "luas.boss3"
require "luas.bossBackground"
require "luas.explosion1000"
require "luas.explosionSmall"
require "luas.explosionMedium"
require "luas.explosionBig"
require "luas.explosionBoss1"
require "luas.explosionBoss2"
require "luas.explosionBoss3"
require "luas.explosionMothership"
require "luas.playerExplosion"
require "luas.maskPrinter"
require "luas.levelSettings"
require "luas.enmBulletA"
require "luas.enmBulletB"
require "luas.enmBulletC"
require "luas.enmBulletD"
require "luas.enmBulletE"
require "luas.enmBulletF"
require "luas.enmBulletG"
require "luas.point"
require "luas.catmullRomSpline"
require "luas.track"
require "luas.powerup"
require "luas.sateliteChunk"
require "luas.sateliteCollectible"
require "luas.ending"

function globInit()																			--Task AAL (part 2) init globals
	
	--define globals, called only once
	globScore = 0
	globMaxScore = 9999999
	
	globMaxPlayers = 1 -- max one players in game
	
	
	globRunningOID = 0--wave 4 267--wave3 206--wave2 116 --will increase with enemies placed along level-content graphic (test it: start game with runningOid = 1 ?)
	
	globMaxEnemyA = 20
	globMaxEnemyB = 30
	globMaxEnemyC = 50
	globMaxEnemyD = 20
	globMaxEnemyE = 15
	globMaxEnemyF = 15
	globMaxEnemyH = 10
	globMaxEnemyI = 20
	globMaxEnemyJ = 20
	globMaxEnemyK = 10
	globMaxEnemyL = 15
	globMaxEnemyM = 15
	globMaxEnemyN = 15
	globMaxEnemyO = 20
	globMaxEnemyP = 10
	globMaxEnemyQ = 20
	globMaxEnemyR = 20
	globMaxEnemyS = 20
	globMaxEnemyT = 50
	globMaxEnemyU = 15
	globMaxEnemyV = 5
	globMaxEnemyW = 10
	globMaxEnemyX = 10
	globMaxEnemyY = 20
	globMaxEnemyZ = 2
	
	--globMaxEnemy = 100
	--globMaxBigEnemy = 30
	
	globLevel = 1
	
	globLevelSettings = LevelSettings()

	--input mapping constants
	GLOB_INPUT_WAITING  = 0
	GLOB_INPUT_KEYBOARD = 1
	GLOB_INPUT_GAMEPAD  = 2
	GLOB_INPUT_MOUSE    = 3
	GLOB_INPUT_COMPUTER = 4 
	GLOB_INPUT_GAMEPAD2 = 5
	GLOB_INPUT_GAMEPAD3 = 6
	GLOB_INPUT_PASSIVE  = 7
	
	--input variables
	globInputType = {}
	
	for i = 1,globMaxPlayers,1 do
		globInputType[i] = GLOB_INPUT_WAITING --empty input
	end
	--to switch input for player i to keyboard, mouse or gamepad do something like
	--globInputType[i] = GLOB_INPUT_KEYBOARD
	
	globNumLifes={} --prepare for up to two players
	--set initial number of lifes.
	--encoding: 
	--## (-2) : player hasnt entered game
	--## (-1) : player has no lifes/game over for that particular player
	--## 0    : player's last life
	--## n    : player's current life + n lifes available
	globNumLifes[1]=2	--## player 1 starts with 3 lifes (current + 2 extra)
	--globNumLifes[2]=(-2) --only 1 player
	--globNumLifes[3]=(-2) --only 1 player
	
	--globally accessable
	globPlayerStartPosX = 30  
	globPlayerStartPosY = 70
	
	globPlayerLeftBounds   = 0
	globPlayerRightBounds  = 184
	globPlayerTopBounds    = 0
	globPlayerBottomBounds = 139
	
	
	--Demo mute countdown (on entering or re-entering DemoMode or GameMode, block fire-key-input for
	--short time so there is no accidential game-restart and no awkward initial fire trigger
	globEntryMuteCountDownIndex    = 0 
	--globEntryMuteCountDown         = 0
	globEntryMuteCountDownMax      = 40
	globEntryMuteCountDownResumePt = 1
	
	
	--TODO register joystick not just at beginning of the game but check repeatedly. for now: 
	globJoystickMul = love.joystick.getJoysticks()
	globJoystick    = globJoystickMul[1] --TODO cannot use multiple joysticks this way
	globJoystick2   = globJoystickMul[2]
	globJoystick3   = globJoystickMul[3]
	
	
	globMaskPrinter = MaskPrinter()
	
	
	--explosion containers will never need to be re-filled with new instances. set them up just once.
	
	globSmallExplosionIndex = 1
	globSmallExplosionMax   = 30
	globSmallExplosions = {}
	for i=1,globSmallExplosionMax,1 do
		globSmallExplosions[i] = ExplosionSmall()
	end
	
	globMediumExplosionIndex = 1
	globMediumExplosionMax   = 30
	globMediumExplosions = {}
	for i=1,globMediumExplosionMax,1 do
		globMediumExplosions[i] = ExplosionMedium()
	end
	
	globBigExplosionIndex = 1
	globBigExplosionMax   = 30
	globBigExplosions = {}
	for i=1,globBigExplosionMax,1 do
		globBigExplosions[i] = ExplosionBig()
	end
	
	globBoss1Explosion = ExplosionBoss1()
	globBoss2Explosion = ExplosionBoss2()
	globBoss3Explosion = ExplosionBoss3()
	
	globPlayerExplosion = PlayerExplosion()
	
	globExplosion1000 = Explosion1000()
	
	globExplosionMothership = ExplosionMothership()
	
	
	--to manage the sounds it needs to be known everywhere whether the game is running in demoMode or gameMode
	globIsInDemoMode = false
	
	
	globScrollWidth = {}
	globScrollWidth[1] = 8000
	globScrollWidth[2] = 8000
	globScrollWidth[3] = 8000
	
	globBossBeaten = false
	globBossBeatTimer = 0
	
	GLOB_DIFFICULTY_EASY = 1
	GLOB_DIFFICULTY_NORMAL = 2
	GLOB_DIFFICULTY_HARD = 3
	globDifficulty = GLOB_DIFFICULTY_NORMAL
	
	globLevelMusic = nil
	
end

function globResetGame()																--Task AAS (part 1) call globals reset for game mode

	globIsInDemoMode = false

	--on entering game, one device has been set and it is needed, so don't reset them.
	--for i = 1,globMaxPlayers,1 do
	--	globInputType[i] = GLOB_INPUT_WAITING 
	--end
	
	globLevel = 1 --with gameMode, keep restarting at level 1

	globScore = 0 --on switch to new game, reset score
	
	--see max players
	if globDifficulty == GLOB_DIFFICULTY_EASY then
		globNumLifes[1]=9	--reset number of lifes
	elseif globDifficulty == GLOB_DIFFICULTY_NORMAL then
		globNumLifes[1]=5	--reset number of lifes
	elseif globDifficulty == GLOB_DIFFICULTY_HARD then
		globNumLifes[1]=3	--reset number of lifes
	end
	--globNumLifes[2]=(-2) --only 1 player
	--globNumLifes[3]=(-2) --only 1 player

	
	globRunningOID = 1--Wave 12: 758--Wave 11: 661--Wave 10: 640 --wave 9: 524--wave 8: 499--wave 7: 445--wave 6 : 409--wave 5: 351 --reset with every new game or else it will go haywire
	

	globResetBasics()
	
	--#fetch input by which demo-mode was left
	--########################################
	
	globInputType[1] = gStateDemo.leaveStateWithDevice
	print("Globals: leaving demo-Mode with input-Type: "..globInputType[1])
	
	--# make first playership enter game using the selected input device
	--##################################################################
	globPlShip[1].enterGame(globPlShip[1],globInputType[1])
	
	
	--reset
	globBossBeaten = false
	globBossBeatTimer = 0

end


function globResetDemo()																--Task AAP (part 2) globals reset for demo

	globIsInDemoMode = true

	
	globLevel = 1 

	--globScore = 0 --on switch to demo, carry last score over
	
	--on switch to demo, reset all input modes to wait for input from player 
	--and determine input device for the next game round. Demomode MUST carry the
	--leaveStateDevice about the input key that caused it to terminate so the inputtype
	--can be initialized for first player. Gamemode must then react to and set the inputs
	--for other players.
	for i = 1,globMaxPlayers,1 do
		globInputType[i] = GLOB_INPUT_WAITING --empty input
		
		globNumLifes[i]=(-2) --number of lifes not defined for demo, demo can't go game over
	end
	globNumLifes[1] = 2 --need globNumLifes > 0 or else ship will deactivate itself in demomode

	globResetBasics()
	
	--demo needs playership too
	--TODO have enterGame() accept parameter for device, like
	--enterGame(globPlShip[1],GLOB_INPUT_WAITING)
	globInputType[1] = GLOB_INPUT_COMPUTER
	--globPlShip[1].enterGame(globPlShip[1], globInputType[1])
	
	--globBGRaster = BackgroundRaster()
	--globBGRaster.enablePsychedelicMode(globBGRaster)
	--globBGRaster.activate(globBGRaster)
end


function globResetBasics()
	
	-- do for both demoMode and gameMode resets
	
	--rebuild playership structures
	globPlShip ={}
	for i = 1,globMaxPlayers,1 do
		globPlShip[i] = PlayerShip()
		globPlShip[i].defineColorType(globPlShip[i],i) --different players need different shipcolors 
	end
	
	--rebuild bullet container structure for playerbullet
	globLeadPlBullets     = {} --no multiple bullet types in this game, only lead bullets
	globLeadPlBulletIndex = {} --bullet index per player, hence use table
	globLeadPlBulletIndexMax  = 16 --reserve so many bullets per player. 
	                       --to see how many are allowed to be actually used,SEE PLAYER CLASS
	
	--reload conditions reside in playerShip
	
	for i = 1,globMaxPlayers,1 do
	
		globLeadPlBullets[i]={}
		globLeadPlBulletIndex[i] = 1 --for each player, start with reference to 1st bullet in container 
	
		for j=1,globLeadPlBulletIndexMax,1 do
			--create 1 bullet per player and bulletslot
			globLeadPlBullets[i][j]  = PlayerBullet()
			
			--different players need different bulletColors
			globLeadPlBullets[i][j].defineColorType(globLeadPlBullets[i][j], i) 
		end
	end
	
	
	
	globEnmBulletsA = {}
	globEnmBulletsAIndex    = 1
	globEnmBulletsAIndexMax = 50
	--
	for i= 1,globEnmBulletsAIndexMax,1 do
		globEnmBulletsA[i] = EnmBulletA()
	end
	
	
	globEnmBulletsB = {}
	globEnmBulletsBIndex    = 1
	globEnmBulletsBIndexMax = 50
	--
	for i= 1,globEnmBulletsBIndexMax,1 do
		globEnmBulletsB[i] = EnmBulletB()
	end
	
	
	globEnmBulletsC = {}
	globEnmBulletsCIndex    = 1
	globEnmBulletsCIndexMax = 50
	--
	for i= 1,globEnmBulletsCIndexMax,1 do
		globEnmBulletsC[i] = EnmBulletC()
	end
	
	
	globEnmBulletsD = {}
	globEnmBulletsDIndex    = 1
	globEnmBulletsDIndexMax = 50
	--
	for i= 1,globEnmBulletsDIndexMax,1 do
		globEnmBulletsD[i] = EnmBulletD()
	end
	
	
	globEnmBulletsE = {}
	globEnmBulletsEIndex    = 1
	globEnmBulletsEIndexMax = 50
	--
	for i= 1,globEnmBulletsEIndexMax,1 do
		globEnmBulletsE[i] = EnmBulletE()
	end
	
	globEnmBulletsF = {}
	globEnmBulletsFIndex    = 1
	globEnmBulletsFIndexMax = 50
	--
	for i= 1,globEnmBulletsFIndexMax,1 do
		globEnmBulletsF[i] = EnmBulletF()
	end
	
	globEnmBulletsG = {}
	globEnmBulletsGIndex    = 1
	globEnmBulletsGIndexMax = 10
	--
	for i= 1,globEnmBulletsGIndexMax,1 do
		globEnmBulletsG[i] = EnmBulletG()
	end
	
	

	--enemy rebuild enemy container structure, also needs to be done on each new level. so:
	globResetLevel()
	
	globEnding = Ending()
	
end

function globResetLevel()
	--throw old enemies away, create new inactive ones that are at idle
	
	globEnemyA={}
	globEnemyAIndex = 1
	for i = 1,globMaxEnemyA,1 do
		globEnemyA[i] = EnemyA() 
	end
	
	globEnemyB={}
	globEnemyBIndex = 1
	for i = 1,globMaxEnemyB,1 do
		globEnemyB[i] = EnemyB() 
	end
	
	globEnemyC={}
	globEnemyCIndex = 1
	for i = 1,globMaxEnemyC,1 do
		globEnemyC[i] = EnemyC() 
	end
	
	globEnemyD={}
	globEnemyDIndex = 1
	for i = 1,globMaxEnemyD,1 do
		globEnemyD[i] = EnemyD() 
	end
	
	globEnemyE={}
	globEnemyEIndex = 1
	for i = 1,globMaxEnemyE,1 do
		globEnemyE[i] = EnemyE() 
	end
	
	globEnemyF={}
	globEnemyFIndex = 1
	for i = 1,globMaxEnemyF,1 do
		globEnemyF[i] = EnemyF() 
	end
	
	globEnemyG = EnemyG()
	
	globEnemyH={}
	globEnemyHIndex = 1
	for i = 1,globMaxEnemyH,1 do
		globEnemyH[i] = EnemyH() 
	end
	
	globEnemyI={}
	globEnemyIIndex = 1
	for i = 1,globMaxEnemyI,1 do
		globEnemyI[i] = EnemyI() 
	end
	
	globEnemyJ={}
	globEnemyJIndex = 1
	for i = 1,globMaxEnemyJ,1 do
		globEnemyJ[i] = EnemyJ() 
	end
	
	globEnemyK={}
	globEnemyKIndex = 1
	for i = 1,globMaxEnemyK,1 do
		globEnemyK[i] = EnemyK() 
	end
	
	globEnemyL={}
	globEnemyLIndex = 1
	for i = 1,globMaxEnemyL,1 do
		globEnemyL[i] = EnemyL() 
	end
	
	globEnemyM={}
	globEnemyMIndex = 1
	for i = 1,globMaxEnemyM,1 do
		globEnemyM[i] = EnemyM() 
	end
	
	globEnemyN={}
	globEnemyNIndex = 1
	for i = 1,globMaxEnemyN,1 do
		globEnemyN[i] = EnemyN() 
	end
	
	globEnemyO={}
	globEnemyOIndex = 1
	for i = 1,globMaxEnemyO,1 do
		globEnemyO[i] = EnemyO() 
	end
	
	globEnemyP={}
	globEnemyPIndex = 1
	for i = 1,globMaxEnemyP,1 do
		globEnemyP[i] = EnemyP() 
	end
	
	globEnemyQ={}
	globEnemyQIndex = 1
	for i = 1,globMaxEnemyQ,1 do
		globEnemyQ[i] = EnemyQ() 
	end
	
	globEnemyR={}
	globEnemyRIndex = 1
	for i = 1,globMaxEnemyR,1 do
		globEnemyR[i] = EnemyR() 
	end
	
	globEnemyS={}
	globEnemySIndex = 1
	for i = 1,globMaxEnemyS,1 do
		globEnemyS[i] = EnemyS() 
	end
	
	globEnemyT={}
	globEnemyTIndex = 1
	for i = 1,globMaxEnemyT,1 do
		globEnemyT[i] = EnemyT() 
	end
	
	globEnemyU={}
	globEnemyUIndex = 1
	for i = 1,globMaxEnemyU,1 do
		globEnemyU[i] = EnemyU() 
	end
	
	globEnemyV={}
	globEnemyVIndex = 1
	for i = 1,globMaxEnemyV,1 do
		globEnemyV[i] = EnemyV() 
	end
	
	globEnemyW={}
	globEnemyWIndex = 1
	for i = 1,globMaxEnemyW,1 do
		globEnemyW[i] = EnemyW() 
	end
	
	globEnemyX={}
	globEnemyXIndex = 1
	for i = 1,globMaxEnemyX,1 do
		globEnemyX[i] = EnemyX() 
	end
	
	globEnemyY={}
	globEnemyYIndex = 1
	for i = 1,globMaxEnemyY,1 do
		globEnemyY[i] = EnemyY() 
	end
	
	globEnemyZ={}
	globEnemyZIndex = 1
	for i = 1,globMaxEnemyZ,1 do
		globEnemyZ[i] = EnemyZ() 
	end
	
	
	globEnemyBoss1 = Boss1()
	globEnemyBoss2 = Boss2()
	globEnemyBoss3 = Boss3()
	
	globBossBack = BossBackground()
	
	--powerup
	globPowerup = Powerup()
	
	--sateliteChunks and sateliteCollectibles
	globSateliteChunk = {}
	globSateliteChunkIndex = 1
	globSateliteChunkIndexMax = 2
	for i = 1,globSateliteChunkIndexMax,1 do
		globSateliteChunk[i] = SateliteChunk()
	end
	
	globSateliteCollectible = {}
	globSateliteCollectibleIndex = 1
	globSateliteCollectibleIndexMax = 2
	for i = 1,globSateliteCollectibleIndexMax,1 do
		globSateliteCollectible[i] = SateliteCollectible()
	end
	
	--also need to deactivate explosions or else explosion animations will carry over from demo mode to game mode
	
	for i=1,globSmallExplosionMax,1 do
		globSmallExplosions[i].deactivate(globSmallExplosions[i])
	end
	
	for i=1,globMediumExplosionMax,1 do
		globMediumExplosions[i].deactivate(globMediumExplosions[i])
	end
	
	for i=1,globBigExplosionMax,1 do
		globBigExplosions[i].deactivate(globBigExplosions[i])
	end
	
	globBoss1Explosion.deactivate(globBoss1Explosion)
	globBoss2Explosion.deactivate(globBoss2Explosion)
	globBoss3Explosion.deactivate(globBoss3Explosion)
	
	globPlayerExplosion.deactivate(globPlayerExplosion)
	
	globExplosion1000.deactivate(globExplosion1000)
	
	globExplosionMothership.deactivate(globExplosionMothership)--obsolete but put it here anyway for consistency reasons
	
	--also reset index used to activate enemies to point to undefined value
	
	globEnemyNextActivationIndex = 0
end

function globFillLevel(aScrollProgress)

	--print("AScrollProgress "..aScrollProgress)

	--point to first enemy
	--globEnemyNextActivationIndex = 1 --not used in this game

	-- analyze current level
	local imgdat = levelGphs[globLevel]:getData()
	local fieldW = imgdat:getWidth()
	local fieldH = imgdat:getHeight()
	
	for j = 1,fieldH, 1 do 
		--for i = 1,fieldW, 1 do --only scan the rightmost line along the y axis, dont need to check for width
		
		local iPos = aScrollProgress + 200 --200 as playfield width
			
		local r, g, b, a =  imgdat:getPixel(iPos, j-1)
		local skip = false
		if r==255 and g==255 and b==254 then
			skip = true
		end
			
			
		if skip == false then --cell has relevant entry
		
			if  r == 1 and g == 1 and b == 10 then
			
				globEnemyA[globEnemyAIndex].setOid(globEnemyA[globEnemyAIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				globEnemyA[globEnemyAIndex].putStartPosition(globEnemyA[globEnemyAIndex], iPos - aScrollProgress, j-1)
				globEnemyA[globEnemyAIndex].activate(globEnemyA[globEnemyAIndex], 0.5)
				globEnemyAIndex = globEnemyAIndex + 1
				if globEnemyAIndex > globMaxEnemyA then
					globEnemyAIndex = 1
				end
			
			elseif  r == 1 and g == 1 and b == 20 then
			
				globEnemyB[globEnemyBIndex].setOid(globEnemyB[globEnemyBIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
			
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)--check additional info pixel
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)--check additional info pixel
				
				globEnemyB[globEnemyBIndex].putStartPosition(globEnemyB[globEnemyBIndex], iPos - aScrollProgress, j-1)
				globEnemyB[globEnemyBIndex].activate(globEnemyB[globEnemyBIndex], 1.7, b2, b3)
				globEnemyBIndex = globEnemyBIndex + 1
				if globEnemyBIndex > globMaxEnemyB then
					globEnemyBIndex = 1
				end
			
			elseif  r == 1 and g == 1 and b == 30 then
			
				globEnemyC[globEnemyCIndex].setOid(globEnemyC[globEnemyCIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
			
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)--check additional info pixel
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)--check additional info pixel
				
				globEnemyC[globEnemyCIndex].putStartPosition(globEnemyC[globEnemyCIndex], iPos - aScrollProgress, j-1)
				if b3 == 0 then --used in lower levels only where it is already in place
					globEnemyC[globEnemyCIndex].setRandomSpeedFlag(globEnemyC[globEnemyCIndex],false)
				elseif b3 == 1 then
					globEnemyC[globEnemyCIndex].setRandomSpeedFlag(globEnemyC[globEnemyCIndex],true)
				elseif b3 == 2 then --for convenience, dont wanna rely on b3 equals zero because it is the transparent color of gfactory and causes troubles
					globEnemyC[globEnemyCIndex].setRandomSpeedFlag(globEnemyC[globEnemyCIndex],false)
				end
				globEnemyC[globEnemyCIndex].activate(globEnemyC[globEnemyCIndex], b2)
				globEnemyCIndex = globEnemyCIndex + 1
				if globEnemyCIndex > globMaxEnemyC then
					globEnemyCIndex = 1
				end
				
			elseif  r == 1 and g == 1 and b == 40 then
				
				globEnemyG.setOid(globEnemyG, globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				
				globEnemyG.setPowerUpType(globEnemyG, b2)
				
				globEnemyG.putStartPosition(globEnemyG, iPos - aScrollProgress, j-1)
				globEnemyG.activate(globEnemyG)
			
			elseif  r == 1 and g == 1 and b == 50 then
			
				globEnemyE[globEnemyEIndex].setOid(globEnemyE[globEnemyEIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				globEnemyE[globEnemyEIndex].putStartPosition(globEnemyE[globEnemyEIndex], iPos - aScrollProgress, j-1)
				globEnemyE[globEnemyEIndex].activate(globEnemyE[globEnemyEIndex])
				globEnemyEIndex = globEnemyEIndex + 1
				if globEnemyEIndex > globMaxEnemyE then
					globEnemyEIndex = 1
				end
			
			elseif  r == 1 and g == 1 and b == 60 then
			
				globEnemyF[globEnemyFIndex].setOid(globEnemyF[globEnemyFIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				globEnemyF[globEnemyFIndex].putStartPosition(globEnemyF[globEnemyFIndex], iPos - aScrollProgress, j-1)
				globEnemyF[globEnemyFIndex].activate(globEnemyF[globEnemyFIndex])
				globEnemyFIndex = globEnemyFIndex + 1
				if globEnemyFIndex > globMaxEnemyF then
					globEnemyFIndex = 1
				end
				
			elseif  r == 1 and g == 1 and b == 70 then
			
				globEnemyI[globEnemyIIndex].setOid(globEnemyI[globEnemyIIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				
				globEnemyI[globEnemyIIndex].putStartPosition(globEnemyI[globEnemyIIndex], iPos - aScrollProgress, j-1)
				globEnemyI[globEnemyIIndex].activate(globEnemyI[globEnemyIIndex], 0.05*b2)
				globEnemyIIndex = globEnemyIIndex + 1
				if globEnemyIIndex > globMaxEnemyI then
					globEnemyIIndex = 1
				end
			
			elseif  r == 1 and g == 1 and b == 80 then
				
				globEnemyJ[globEnemyJIndex].setOid(globEnemyJ[globEnemyJIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				
				globEnemyJ[globEnemyJIndex].putStartPosition(globEnemyJ[globEnemyJIndex], iPos - aScrollProgress, j-1)
				globEnemyJ[globEnemyJIndex].activate(globEnemyJ[globEnemyJIndex], 0.05*b2)
				globEnemyJIndex = globEnemyJIndex + 1
				if globEnemyJIndex > globMaxEnemyJ then
					globEnemyJIndex = 1
				end
				
			elseif  r == 1 and g == 1 and b == 90 then
				
				globEnemyL[globEnemyLIndex].setOid(globEnemyL[globEnemyLIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)
				
				globEnemyL[globEnemyLIndex].setStartTimer(globEnemyL[globEnemyLIndex], b2)
				globEnemyL[globEnemyLIndex].putStartPosition(globEnemyL[globEnemyLIndex], iPos - aScrollProgress, j-1)
				globEnemyL[globEnemyLIndex].activate(globEnemyL[globEnemyLIndex], 0.05*b3)
				globEnemyLIndex = globEnemyLIndex + 1
				if globEnemyLIndex > globMaxEnemyL then
					globEnemyLIndex = 1
				end
			
			elseif  r == 1 and g == 1 and b == 100 then
				
				globEnemyM[globEnemyMIndex].setOid(globEnemyM[globEnemyMIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)
				local r4, g4, b4, a4 =  imgdat:getPixel(iPos+3, j-1)
				
				if b2 == 1 then
					globEnemyM[globEnemyMIndex].setStartBowDown(globEnemyM[globEnemyMIndex], true)
				elseif b2 == 2 then
					globEnemyM[globEnemyMIndex].setStartBowDown(globEnemyM[globEnemyMIndex], false)
				end
				globEnemyM[globEnemyMIndex].setShotSpdFactor(globEnemyM[globEnemyMIndex], b4*0.05)
				globEnemyM[globEnemyMIndex].setStartOffset(globEnemyM[globEnemyMIndex], b3)
				globEnemyM[globEnemyMIndex].putStartPosition(globEnemyM[globEnemyMIndex], iPos - aScrollProgress, j-1)
				globEnemyM[globEnemyMIndex].activate(globEnemyM[globEnemyMIndex])
				globEnemyMIndex = globEnemyMIndex + 1
				if globEnemyMIndex > globMaxEnemyM then
					globEnemyMIndex = 1
				end
			
			elseif  r == 1 and g == 1 and b == 110 then
			
				globEnemyO[globEnemyOIndex].setOid(globEnemyO[globEnemyOIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)
				
				globEnemyO[globEnemyOIndex].setStartOffset(globEnemyO[globEnemyOIndex], b3)
				globEnemyO[globEnemyOIndex].putStartPosition(globEnemyO[globEnemyOIndex], iPos - aScrollProgress, j-1)
				globEnemyO[globEnemyOIndex].activate(globEnemyO[globEnemyOIndex], b2*0.05)
				globEnemyOIndex = globEnemyOIndex + 1
				if globEnemyOIndex > globMaxEnemyO then
					globEnemyOIndex = 1
				end
				
			elseif  r == 1 and g == 1 and b == 120 then
			
				globEnemyP[globEnemyPIndex].setOid(globEnemyP[globEnemyPIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)
				local r4, g4, b4, a4 =  imgdat:getPixel(iPos+3, j-1)
				local r5, g5, b5, a5 =  imgdat:getPixel(iPos+4, j-1)
				
				local lclPreSign = 0.0
				if b4 == 1 then
					lclPreSign = 1.0
				elseif b4 == 2 then
					lclPreSign = (-1)*1.0
				end
				
				globEnemyP[globEnemyPIndex].setStartOffset(globEnemyP[globEnemyPIndex], b5)
				globEnemyP[globEnemyPIndex].putStartPosition(globEnemyP[globEnemyPIndex], iPos - aScrollProgress, j-1)
				globEnemyP[globEnemyPIndex].activate(globEnemyP[globEnemyPIndex], b2*0.05, b3*0.05*lclPreSign)
				globEnemyPIndex = globEnemyPIndex + 1
				if globEnemyPIndex > globMaxEnemyP then
					globEnemyPIndex = 1
				end
				
			elseif  r == 1 and g == 1 and b == 130 then	
				
				globEnemyQ[globEnemyQIndex].setOid(globEnemyQ[globEnemyQIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				
				globEnemyQ[globEnemyQIndex].putStartPosition(globEnemyQ[globEnemyQIndex], iPos - aScrollProgress, j-1)
				globEnemyQ[globEnemyQIndex].activate(globEnemyQ[globEnemyQIndex], b2*0.05)
				globEnemyQIndex = globEnemyQIndex + 1
				if globEnemyQIndex > globMaxEnemyQ then
					globEnemyQIndex = 1
				end
				
			elseif  r == 1 and g == 1 and b == 140 then	
				
				globEnemyR[globEnemyRIndex].setOid(globEnemyR[globEnemyRIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)
				
				globEnemyR[globEnemyRIndex].setShootTimer(globEnemyR[globEnemyRIndex], b3)
				globEnemyR[globEnemyRIndex].putStartPosition(globEnemyR[globEnemyRIndex], iPos - aScrollProgress, j-1)
				globEnemyR[globEnemyRIndex].activate(globEnemyR[globEnemyRIndex], b2*0.05)
				globEnemyRIndex = globEnemyRIndex + 1
				if globEnemyRIndex > globMaxEnemyR then
					globEnemyRIndex = 1
				end
				
			elseif  r == 1 and g == 1 and b == 150 then	
				
				globEnemyS[globEnemySIndex].setOid(globEnemyS[globEnemySIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)
				local r4, g4, b4, a4 =  imgdat:getPixel(iPos+3, j-1)
				
				globEnemyS[globEnemySIndex].setStartTimer(globEnemyS[globEnemySIndex], b2)
				globEnemyS[globEnemySIndex].setDeflection(globEnemyS[globEnemySIndex], b3)
				globEnemyS[globEnemySIndex].setDangleTimer(globEnemyS[globEnemySIndex], b4*10)
				globEnemyS[globEnemySIndex].putStartPosition(globEnemyS[globEnemySIndex], iPos - aScrollProgress, j-1)
				globEnemyS[globEnemySIndex].activate(globEnemyS[globEnemySIndex], 0.75)
				globEnemySIndex = globEnemySIndex + 1
				if globEnemySIndex > globMaxEnemyS then
					globEnemySIndex = 1
				end
				
			elseif  r == 1 and g == 1 and b == 160 then
			
				globEnemyT[globEnemyTIndex].setOid(globEnemyT[globEnemyTIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
			
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)--check additional info pixel
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)--check additional info pixel
				
				globEnemyT[globEnemyTIndex].putStartPosition(globEnemyT[globEnemyTIndex], iPos - aScrollProgress, j-1)
				if b3 == 0 then --used in lower levels only where it is already in place
					globEnemyT[globEnemyTIndex].setRandomSpeedFlag(globEnemyT[globEnemyTIndex],false)
				elseif b3 == 1 then
					globEnemyT[globEnemyTIndex].setRandomSpeedFlag(globEnemyT[globEnemyTIndex],true)
				elseif b3 == 2 then	--for convenience, dont wanna rely on b3 equals zero because it is the transparent color of gfactory and causes troubles
					globEnemyT[globEnemyTIndex].setRandomSpeedFlag(globEnemyT[globEnemyTIndex],false)
				end
				globEnemyT[globEnemyTIndex].activate(globEnemyT[globEnemyTIndex], b2)
				globEnemyTIndex = globEnemyTIndex + 1
				if globEnemyTIndex > globMaxEnemyT then
					globEnemyTIndex = 1
				end
				
			elseif  r == 1 and g == 1 and b == 170 then
				
				globEnemyU[globEnemyUIndex].setOid(globEnemyU[globEnemyUIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)
				local r4, g4, b4, a4 =  imgdat:getPixel(iPos+3, j-1)
				local r5, g5, b5, a5 =  imgdat:getPixel(iPos+4, j-1)
				
				globEnemyU[globEnemyUIndex].setStartDestCoordinate(globEnemyU[globEnemyUIndex], b2, b3)
				globEnemyU[globEnemyUIndex].setContinueDestCoordinate(globEnemyU[globEnemyUIndex], b4)
				globEnemyU[globEnemyUIndex].putStartPosition(globEnemyU[globEnemyUIndex], iPos - aScrollProgress, j-1)
				globEnemyU[globEnemyUIndex].activate(globEnemyU[globEnemyUIndex], 0.05*b5)
				globEnemyUIndex = globEnemyUIndex + 1
				if globEnemyUIndex > globMaxEnemyU then
					globEnemyUIndex = 1
				end
			
			elseif  r == 1 and g == 1 and b == 180 then
			
				globEnemyV[globEnemyVIndex].setOid(globEnemyV[globEnemyVIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)
				local r4, g4, b4, a4 =  imgdat:getPixel(iPos+3, j-1)
				
				globEnemyV[globEnemyVIndex].setStartTimer(globEnemyV[globEnemyVIndex], b2)
				globEnemyV[globEnemyVIndex].setCycles(globEnemyV[globEnemyVIndex], b3)
				globEnemyV[globEnemyVIndex].putStartPosition(globEnemyV[globEnemyVIndex], iPos - aScrollProgress, j-1)
				globEnemyV[globEnemyVIndex].activate(globEnemyV[globEnemyVIndex], 0.05*b4)
				globEnemyVIndex = globEnemyVIndex + 1
				if globEnemyVIndex > globMaxEnemyV then
					globEnemyVIndex = 1
				end
				
			elseif  r == 1 and g == 1 and b == 190 then
				
				globEnemyX[globEnemyXIndex].setOid(globEnemyX[globEnemyXIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)
				
				globEnemyX[globEnemyXIndex].setStartTimer(globEnemyX[globEnemyXIndex], b2)
				globEnemyX[globEnemyXIndex].putStartPosition(globEnemyX[globEnemyXIndex], iPos - aScrollProgress, j-1)
				globEnemyX[globEnemyXIndex].activate(globEnemyX[globEnemyXIndex], 0.05*b3)
				globEnemyXIndex = globEnemyXIndex + 1
				if globEnemyXIndex > globMaxEnemyX then
					globEnemyXIndex = 1
				end
				
			elseif  r == 1 and g == 1 and b == 200 then
			
			
				globEnemyY[globEnemyYIndex].setOid(globEnemyY[globEnemyYIndex], globRunningOID)
				globRunningOID = globRunningOID + 1
				
				local r2, g2, b2, a2 =  imgdat:getPixel(iPos+1, j-1)
				local r3, g3, b3, a3 =  imgdat:getPixel(iPos+2, j-1)
				local r4, g4, b4, a4 =  imgdat:getPixel(iPos+3, j-1)
				
				if b2 == 1 then
					globEnemyY[globEnemyYIndex].setUpsideDown(globEnemyY[globEnemyYIndex], false)
				elseif b2 == 2 then
					globEnemyY[globEnemyYIndex].setUpsideDown(globEnemyY[globEnemyYIndex], true)
				end
				globEnemyY[globEnemyYIndex].setMagnitude(globEnemyY[globEnemyYIndex], 0.3*b3)
				globEnemyY[globEnemyYIndex].putStartPosition(globEnemyY[globEnemyYIndex], iPos - aScrollProgress, j-1)
				globEnemyY[globEnemyYIndex].activate(globEnemyY[globEnemyYIndex], 0.05*b4)
				globEnemyYIndex = globEnemyYIndex + 1
				if globEnemyYIndex > globMaxEnemyY then
					globEnemyYIndex = 1
				end
				
				
				
			end
		
		end
	end
	
	
	--spawning enemies based on aScrollProgress alone
	if globLevel == 1 then
	
		if  aScrollProgress == 1 then
		
			globLevelMusic = level1Music
			globLevelMusic:setVolume(1.0) --need to do because it could be less than 1.0 from fadeout of previous run
			globLevelMusic:stop()
			globLevelMusic:play()
			
		elseif aScrollProgress == 1480 then
		
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10000)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 170, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
		
		elseif aScrollProgress == 1570 then
		
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10001)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 140, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
		
		elseif aScrollProgress == 1600 then
		
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10002)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 190, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
		
		elseif aScrollProgress == 1780 then
		
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10003)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 170, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
		elseif aScrollProgress == 2650 then
		
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10004)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 180, (-1)*10)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, 1.0)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
		
		elseif aScrollProgress == 2800 then
		
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10005)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 180, 160)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, (-1)*1.0)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
			
		elseif aScrollProgress == 2889 then
		
			--insert enemy k
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			local lclP11X = 0
			local lclP11Y = 0
			local lclP12X = 0
			local lclP12Y = 0
			
			lclP1X = 210
			lclP1Y = 15
			lclP2X = 210
			lclP2Y = 15
			lclP3X = 180
			lclP3Y = 15
			lclP4X = 170
			lclP4Y = 120
			lclP5X = 140
			lclP5Y = 120
			lclP6X = 150
			lclP6Y = 80
			lclP7X = 190
			lclP7Y = 80
			lclP8X = 190
			lclP8Y = 55
			lclP9X = 70
			lclP9Y = 65
			lclP10X = 80
			lclP10Y = 100
			lclP11X = -50
			lclP11Y = 100
			lclP12X = -50
			lclP12Y = 100
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[11] = Point()
			lclPts[12] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			lclPts[11].putPosition(lclPts[11], lclP11X, lclP11Y)
			lclPts[12].putPosition(lclPts[12], lclP12X, lclP12Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			--
			lclSplines[8] =  CatmullRomSpline()
			lclSplines[8].setGoodDist(lclSplines[8], lclGoodDist)
			lclSplines[8].setRefPoints(lclSplines[8], lclPts[8], lclPts[9], lclPts[10], lclPts[11])
			lclSplines[8].calculate(lclSplines[8])
			--
			lclSplines[9] =  CatmullRomSpline()
			lclSplines[9].setGoodDist(lclSplines[9], lclGoodDist)
			lclSplines[9].setRefPoints(lclSplines[9], lclPts[9], lclPts[10], lclPts[11], lclPts[12])
			lclSplines[9].calculate(lclSplines[9])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			lclTrack.addSpline(lclTrack, lclSplines[8])
			lclTrack.addSpline(lclTrack, lclSplines[9])
			
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10008)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 15)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end
			
		elseif aScrollProgress == 3049 then
		
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10012)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 90, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
		
		elseif aScrollProgress == 3100 then
		
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10006)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 160, (-1)*10)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, 1.2)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
			
		elseif aScrollProgress == 3127 then
		
		
			--insert enemy k
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			local lclP11X = 0
			local lclP11Y = 0
			local lclP12X = 0
			local lclP12Y = 0
			local lclP13X = 0
			local lclP13Y = 0
			local lclP14X = 0
			local lclP14Y = 0
			
			lclP1X = 210
			lclP1Y = 25
			lclP2X = 210
			lclP2Y = 25
			lclP3X = 175
			lclP3Y = 25
			lclP4X = 175
			lclP4Y = 125
			lclP5X = 100
			lclP5Y = 125
			lclP6X = 100
			lclP6Y = 35
			lclP7X = 130
			lclP7Y = 35
			lclP8X = 130
			lclP8Y = 80
			lclP9X = 70
			lclP9Y = 80
			lclP10X = 70
			lclP10Y = 120
			lclP11X = 40
			lclP11Y = 120
			lclP12X = 40
			lclP12Y = 35
			lclP13X = -50
			lclP13Y = 35
			lclP14X = -50
			lclP14Y = 35
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[11] = Point()
			lclPts[12] = Point()
			lclPts[13] = Point()
			lclPts[14] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			lclPts[11].putPosition(lclPts[11], lclP11X, lclP11Y)
			lclPts[12].putPosition(lclPts[12], lclP12X, lclP12Y)
			lclPts[13].putPosition(lclPts[13], lclP13X, lclP13Y)
			lclPts[14].putPosition(lclPts[14], lclP14X, lclP14Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			--
			lclSplines[8] =  CatmullRomSpline()
			lclSplines[8].setGoodDist(lclSplines[8], lclGoodDist)
			lclSplines[8].setRefPoints(lclSplines[8], lclPts[8], lclPts[9], lclPts[10], lclPts[11])
			lclSplines[8].calculate(lclSplines[8])
			--
			lclSplines[9] =  CatmullRomSpline()
			lclSplines[9].setGoodDist(lclSplines[9], lclGoodDist)
			lclSplines[9].setRefPoints(lclSplines[9], lclPts[9], lclPts[10], lclPts[11], lclPts[12])
			lclSplines[9].calculate(lclSplines[9])
			--
			lclSplines[10] =  CatmullRomSpline()
			lclSplines[10].setGoodDist(lclSplines[10], lclGoodDist)
			lclSplines[10].setRefPoints(lclSplines[10], lclPts[10], lclPts[11], lclPts[12], lclPts[13])
			lclSplines[10].calculate(lclSplines[10])
			--
			lclSplines[11] =  CatmullRomSpline()
			lclSplines[11].setGoodDist(lclSplines[11], lclGoodDist)
			lclSplines[11].setRefPoints(lclSplines[11], lclPts[11], lclPts[12], lclPts[13], lclPts[14])
			lclSplines[11].calculate(lclSplines[11])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			lclTrack.addSpline(lclTrack, lclSplines[8])
			lclTrack.addSpline(lclTrack, lclSplines[9])
			lclTrack.addSpline(lclTrack, lclSplines[10])
			lclTrack.addSpline(lclTrack, lclSplines[11])
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10009)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 25)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end
			
		elseif aScrollProgress == 3196 then
		
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10013)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 140, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
		
		elseif aScrollProgress == 3250 then
		
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10007)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 170, 160)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, (-1)*1.2)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
		
		elseif aScrollProgress == 3419 then
		
			--insert enemy k
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			
			lclP1X = 210
			lclP1Y = 120
			lclP2X = 210
			lclP2Y = 120
			lclP3X = 165
			lclP3Y = 120
			lclP4X = 155
			lclP4Y = 30
			lclP5X = 135
			lclP5Y = 30
			lclP6X = 120
			lclP6Y = 90
			lclP7X = -50
			lclP7Y = 70
			lclP8X = -50
			lclP8Y = 70
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10010)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 120)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end
		
		elseif aScrollProgress == 3686 then
		
			--insert enemy k
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			local lclP11X = 0
			local lclP11Y = 0
			local lclP12X = 0
			local lclP12Y = 0
			local lclP13X = 0
			local lclP13Y = 0
			local lclP14X = 0
			local lclP14Y = 0
			
			lclP1X = 210
			lclP1Y = 50
			lclP2X = 210
			lclP2Y = 50
			lclP3X = 175
			lclP3Y = 20
			lclP4X = 160
			lclP4Y = 75
			lclP5X = 180
			lclP5Y = 110
			lclP6X = 100
			lclP6Y = 120
			lclP7X = 30
			lclP7Y = 105
			lclP8X = 65
			lclP8Y = 60
			lclP9X = 50
			lclP9Y = 25
			lclP10X = 30
			lclP10Y = 40
			lclP11X = 70
			lclP11Y = 80
			lclP12X = 45
			lclP12Y = 95
			lclP13X = -50
			lclP13Y = 80
			lclP14X = -50
			lclP14Y = 80
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[11] = Point()
			lclPts[12] = Point()
			lclPts[13] = Point()
			lclPts[14] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			lclPts[11].putPosition(lclPts[11], lclP11X, lclP11Y)
			lclPts[12].putPosition(lclPts[12], lclP12X, lclP12Y)
			lclPts[13].putPosition(lclPts[13], lclP13X, lclP13Y)
			lclPts[14].putPosition(lclPts[14], lclP14X, lclP14Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			--
			lclSplines[8] =  CatmullRomSpline()
			lclSplines[8].setGoodDist(lclSplines[8], lclGoodDist)
			lclSplines[8].setRefPoints(lclSplines[8], lclPts[8], lclPts[9], lclPts[10], lclPts[11])
			lclSplines[8].calculate(lclSplines[8])
			--
			lclSplines[9] =  CatmullRomSpline()
			lclSplines[9].setGoodDist(lclSplines[9], lclGoodDist)
			lclSplines[9].setRefPoints(lclSplines[9], lclPts[9], lclPts[10], lclPts[11], lclPts[12])
			lclSplines[9].calculate(lclSplines[9])
			--
			lclSplines[10] =  CatmullRomSpline()
			lclSplines[10].setGoodDist(lclSplines[10], lclGoodDist)
			lclSplines[10].setRefPoints(lclSplines[10], lclPts[10], lclPts[11], lclPts[12], lclPts[13])
			lclSplines[10].calculate(lclSplines[10])
			--
			lclSplines[11] =  CatmullRomSpline()
			lclSplines[11].setGoodDist(lclSplines[11], lclGoodDist)
			lclSplines[11].setRefPoints(lclSplines[11], lclPts[11], lclPts[12], lclPts[13], lclPts[14])
			lclSplines[11].calculate(lclSplines[11])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			lclTrack.addSpline(lclTrack, lclSplines[8])
			lclTrack.addSpline(lclTrack, lclSplines[9])
			lclTrack.addSpline(lclTrack, lclSplines[10])
			lclTrack.addSpline(lclTrack, lclSplines[11])
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10011)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 50)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end
		
		elseif aScrollProgress == 3891 then
		
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10014)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 130, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
		
		elseif aScrollProgress == 3976 then
		
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10015)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 130, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
		elseif aScrollProgress == 4375 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10017)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 170, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		
		elseif aScrollProgress == 4560 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10018)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 140, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 4580 then
		
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10021)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 100, 160)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, (-1)*0.8)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
		
		
		elseif aScrollProgress == 4630 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10019)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 70, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 4760 then
		
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10020)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 120, (-1)*10)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, 1.2)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
		
		elseif aScrollProgress == 4860 then
		
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10022)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 150, (-1)*10)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, 0.7)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
		
		elseif aScrollProgress == 5000 then
		
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10023)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 110, (-1)*10)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, 0.7)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
			
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10024)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 110, 160)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, (-1)*0.7)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
		
		elseif aScrollProgress == 5060 then
		
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10025)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 150, (-1)*10)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, 0.9)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
			
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10026)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 150, 160)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, (-1)*0.9)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
			
			
			
		elseif aScrollProgress == 5950 then	
		
			--insert enemy k
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			local lclP11X = 0
			local lclP11Y = 0
			local lclP12X = 0
			local lclP12Y = 0
			
			lclP1X = 210
			lclP1Y = 125
			lclP2X = 210
			lclP2Y = 125
			lclP3X = 160
			lclP3Y = 125
			lclP4X = 160
			lclP4Y = 70
			lclP5X = 175
			lclP5Y = 70
			lclP6X = 175
			lclP6Y = 100
			lclP7X = 60
			lclP7Y = 100
			lclP8X = 60
			lclP8Y = 20
			lclP9X = 80
			lclP9Y = 20
			lclP10X = 80
			lclP10Y = 75
			lclP11X = -50
			lclP11Y = 75
			lclP12X = -50
			lclP12Y = 75
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[11] = Point()
			lclPts[12] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			lclPts[11].putPosition(lclPts[11], lclP11X, lclP11Y)
			lclPts[12].putPosition(lclPts[12], lclP12X, lclP12Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			--
			lclSplines[8] =  CatmullRomSpline()
			lclSplines[8].setGoodDist(lclSplines[8], lclGoodDist)
			lclSplines[8].setRefPoints(lclSplines[8], lclPts[8], lclPts[9], lclPts[10], lclPts[11])
			lclSplines[8].calculate(lclSplines[8])
			--
			lclSplines[9] =  CatmullRomSpline()
			lclSplines[9].setGoodDist(lclSplines[9], lclGoodDist)
			lclSplines[9].setRefPoints(lclSplines[9], lclPts[9], lclPts[10], lclPts[11], lclPts[12])
			lclSplines[9].calculate(lclSplines[9])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			lclTrack.addSpline(lclTrack, lclSplines[8])
			lclTrack.addSpline(lclTrack, lclSplines[9])
			
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10027)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 125)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end
		
		elseif aScrollProgress == 6000 then	
		
			--insert enemy k
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			
			lclP1X = 210
			lclP1Y = 35
			lclP2X = 210
			lclP2Y = 35
			lclP3X = 100
			lclP3Y = 35
			lclP4X = 100
			lclP4Y = 115
			lclP5X = 135
			lclP5Y = 115
			lclP6X = 135
			lclP6Y = 80
			lclP7X = 70
			lclP7Y = 80
			lclP8X = 70
			lclP8Y = 110
			lclP9X = (-1)*50
			lclP9Y = 110
			lclP10X = (-1)*50
			lclP10Y = 110
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10028)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 35)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end
		
		elseif aScrollProgress == 6190 then	
		
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10029)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 150, (-1)*10)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, 0.9)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
			
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10030)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 150, 160)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, (-1)*0.9)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
			
		
		elseif aScrollProgress == 6200 then	
		
					--insert enemy k
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			
			lclP1X = 210
			lclP1Y = 65
			lclP2X = 210
			lclP2Y = 65
			lclP3X = 160
			lclP3Y = 65
			lclP4X = 160
			lclP4Y = 20
			lclP5X = 120
			lclP5Y = 20
			lclP6X = 120
			lclP6Y = 120
			lclP7X = 80
			lclP7Y = 120
			lclP8X = 80
			lclP8Y = 65
			lclP9X = (-1)*50
			lclP9Y = 65
			lclP10X = (-1)*50
			lclP10Y = 65
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10031)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 65)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end
			
		elseif aScrollProgress == 7600 then	
			globLevelMusic:setVolume(0.9)
		elseif aScrollProgress == 7620 then	
			globLevelMusic:setVolume(0.8)
		elseif aScrollProgress == 7640 then	
			globLevelMusic:setVolume(0.7)
		elseif aScrollProgress == 7660 then	
			globLevelMusic:setVolume(0.6)
		elseif aScrollProgress == 7680 then	
			globLevelMusic:setVolume(0.5)
		elseif aScrollProgress == 7700 then	
			globLevelMusic:setVolume(0.4)
		elseif aScrollProgress == 7720 then	
			globLevelMusic:setVolume(0.3)
		elseif aScrollProgress == 7740 then	
			globLevelMusic:setVolume(0.2)
		elseif aScrollProgress == 7760 then	
			globLevelMusic:setVolume(0.1)
		elseif aScrollProgress == 7780 then	
			globLevelMusic:stop()
		elseif aScrollProgress == 7799 then	
		
			--Boss 1
			
			globEnemyBoss1.putStartPosition(globEnemyBoss1, 200, 55)
			globEnemyBoss1.activate(globEnemyBoss1)
		
			globLevelMusic = bossMusic
			globLevelMusic:setVolume(1.0)
			globLevelMusic:stop()
			globLevelMusic:play()
		
		end
		
		
		--have enemies shoot
		if aScrollProgress == 372 then
			enemyShoot(7, (-1)*2.0, 1.0, false, 0, 0)
		elseif aScrollProgress == 530 then
			enemyShoot(8, (-1)*2.0, 1.0, false, 0, 0)
		elseif aScrollProgress == 670 then
			enemyShoot(9, (-1)*2.0, (-1)*1.0, false, 0, 0)
		elseif aScrollProgress == 900 then--830 then
			enemyShoot(13, (-1)*2.5, (-1)*1.0, false, 0, 0)
		elseif aScrollProgress == 1000 then
			enemyShoot(13, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1230 then
			enemyShoot(19, (-1)*2.5, 1.0, false, 0, 0)
			enemyShoot(20, (-1)*2.5, (-1)*1.0, false, 0, 0)
		elseif aScrollProgress == 1500 then
			enemyShoot(10000, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1633 then
			enemyShoot(10002, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1834 then
			enemyShoot(10003, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1913 then
			enemyShoot(43, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1988 then
			enemyShoot(44, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2064 then
			enemyShoot(44, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2152 then
			enemyShoot(46, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2172 then
			enemyShoot(50, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2191 then
			enemyShoot(47, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2249 then
			enemyShoot(49, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2301 then
			enemyShoot(50, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2357 then
			enemyShoot(56, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2431 then
			enemyShoot(57, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2476 then
			enemyShoot(59, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2508 then
			enemyShoot(57, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2692 then
			enemyShoot(10004, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2757 then
			enemyShoot(10004, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2795 then
			enemyShoot(82, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2810 then
			enemyShoot(83, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2827 then
			enemyShoot(82, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2841 then
			enemyShoot(84, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2844 then
			enemyShoot(10005, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2864 then
			enemyShoot(82, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2875 then
			enemyShoot(83, 0.0, 0.0, false, 0, 0)			
		elseif aScrollProgress == 2894 then
			enemyShoot(10005, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2932 then
			enemyShoot(10005, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2934 then
			enemyShoot(10008, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 2938 then
			enemyShoot(85, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2980 then
			enemyShoot(10008, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2996 then
			enemyShoot(85, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3064 then
			enemyShoot(10008, 0.0, 0.0, false, 1, 0)			
		elseif aScrollProgress == 3130 then
			enemyShoot(10006, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3175 then
			enemyShoot(10009, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3180 then
			enemyShoot(10006, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3190 then
			enemyShoot(10008, 0.0, 0.0, false, 2, 0)
		elseif aScrollProgress == 3191 then
			enemyShoot(88, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 3259 then
			enemyShoot(10008, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 3265 then
			enemyShoot(89, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 3300 then
			enemyShoot(10007, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3313 then
			enemyShoot(10009, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 3335 then
			enemyShoot(91, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 3345 then
			enemyShoot(10007, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3418 then
			enemyShoot(10009, 0.0, 0.0, false, 2, 0)
		elseif aScrollProgress == 3470 then
			enemyShoot(10010, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 3512 then
			enemyShoot(10009, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 3531 then
			enemyShoot(10010, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3589 then
			enemyShoot(10010, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 3600 then
			enemyShoot(98, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 3618 then
			enemyShoot(10009, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3664 then
			enemyShoot(10010, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3720 then
			enemyShoot(103, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 3730 then
			enemyShoot(10011, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3770 then
			enemyShoot(10011, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 3910 then
			enemyShoot(10014, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 3959 then
			enemyShoot(10014, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 3960 then
			enemyShoot(10011, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 4027 then
			enemyShoot(10011, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 4045 then
			enemyShoot(10015, 0.0, 0.0, true, 0, 0)
		--wave2
		elseif aScrollProgress == 4281 then
			enemyShoot(120, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 4298 then
			enemyShoot(119, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 4330 then
			enemyShoot(124, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 4334 then
			enemyShoot(120, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 4362 then
			enemyShoot(126, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 4387 then
			enemyShoot(123, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 4483 then
			enemyShoot(130, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 4524 then
			enemyShoot(134, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 4847 then
			enemyShoot(144, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 4980 then
			enemyShoot(150, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 5537 then
			enemyShoot(191, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 5681 then
			enemyShoot(195, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 5773 then
			enemyShoot(198, 0.0, 0.0, true, 0, 0)
		--wave3
		elseif aScrollProgress == 6000 then
			enemyShoot(10027, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 6035 then
			enemyShoot(10027, 0.0, 0.0, false, 2, 0)
		elseif aScrollProgress == 6049 then
			enemyShoot(10028, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 6134 then
			enemyShoot(10028, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 6198 then
			enemyShoot(10027, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 6223 then
			enemyShoot(10029, 0.0, 0.0, false, 0, 0)
			enemyShoot(10030, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 6260 then
			enemyShoot(10031, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 6288 then
			enemyShoot(10029, 0.0, 0.0, false, 0, 0)
			enemyShoot(10030, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 6340 then
			enemyShoot(10031, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 6445 then
			enemyShoot(10031, 0.0, 0.0, false, 1, 0)
		elseif aScrollProgress == 6487 then
			enemyShoot(221, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 6618 then
			enemyShoot(222, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 6795 then
			enemyShoot(238, 0.0, 0.0, false, 0, 0)
			enemyShoot(239, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 6927 then
			enemyShoot(238, 0.0, 0.0, false, 0, 0)
			enemyShoot(239, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 7168 then
			enemyShoot(250, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 7248 then
			enemyShoot(251, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 7262 then
			enemyShoot(252, 0.0, 0.0, true, 0, 0)
		
		
		end
		
		
		
	
	elseif globLevel == 2 then
	
	
		if aScrollProgress == 1 then
		
			globLevelMusic = level2Music
			globLevelMusic:setVolume(1.0)
			globLevelMusic:stop()
			globLevelMusic:play()
		
		elseif aScrollProgress == 500 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10032)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 80, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 619 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10033)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 110, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 671 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10034)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 150, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 768 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10035)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 170, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 1869 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10036)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 70, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
			
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10040)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 70, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		
		elseif aScrollProgress == 1944 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10037)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 180, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
			
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10041)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 180, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 2023 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10038)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 50, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
			
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10042)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 50, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 2124 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10039)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 140, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
			
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10043)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 140, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
			
		elseif aScrollProgress == 2248 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10044)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 170, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 2318 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10045)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 120, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 2446 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10046)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 150, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 2645 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10047)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 110, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 2830 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10048)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 110, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
			
		elseif aScrollProgress == 5534 then
			
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10049)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 120, 50)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,80)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 50, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 5560 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10050)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 60, 100)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 110,(-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 150, 170)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 5632 then
			
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10051)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 100, 70)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 40,(-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, 50)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
		
		elseif aScrollProgress == 5660 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10052)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 160, 40)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,40)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10053)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 160, 90)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,90)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, 160)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 5740 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10054)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 60, 80)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 180,(-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 100, 160)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
		
		elseif aScrollProgress == 5830 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10055)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 110, 55)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 180,(-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 140, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 5850 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10056)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 10, 10)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 210,160)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], (-1)*20, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 5930 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10057)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 155, 65)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 125,(-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], (-1)*20, 65)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
		
		elseif aScrollProgress == 5958 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10060)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 90, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 6000 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10058)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 110, 40)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,40)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10059)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 110, 90)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,90)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, 160)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 6104 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10061)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 160, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 7600 then	
			globLevelMusic:setVolume(0.9)
		elseif aScrollProgress == 7620 then	
			globLevelMusic:setVolume(0.8)
		elseif aScrollProgress == 7640 then	
			globLevelMusic:setVolume(0.7)
		elseif aScrollProgress == 7660 then	
			globLevelMusic:setVolume(0.6)
		elseif aScrollProgress == 7680 then	
			globLevelMusic:setVolume(0.5)
		elseif aScrollProgress == 7700 then	
			globLevelMusic:setVolume(0.4)
		elseif aScrollProgress == 7720 then	
			globLevelMusic:setVolume(0.3)
		elseif aScrollProgress == 7740 then	
			globLevelMusic:setVolume(0.2)
		elseif aScrollProgress == 7760 then	
			globLevelMusic:setVolume(0.1)
		elseif aScrollProgress == 7780 then	
			globLevelMusic:stop()
		elseif aScrollProgress == 7799 then	
		
			--Boss 2
			
			globEnemyBoss2.putStartPosition(globEnemyBoss2, 200, 0)
			globEnemyBoss2.activate(globEnemyBoss2)
			
			globLevelMusic = bossMusic
			globLevelMusic:setVolume(1.0)
			globLevelMusic:stop()
			globLevelMusic:play()
			
		end
		
		
		--have enemies shoot
		if aScrollProgress == 200 then
			enemyShoot(275, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 238 then
			enemyShoot(276, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 261 then
			enemyShoot(275, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 277 then
			enemyShoot(278, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 291 then
			enemyShoot(279, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 292 then
			enemyShoot(277, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 355 then
			enemyShoot(267, (-1)*1.5, 1.0, false, 0, 0)
			enemyShoot(268, (-1)*1.5, (-1)*1.0, false, 0, 0)
		elseif aScrollProgress == 360 then
			enemyShoot(280, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 391 then
			enemyShoot(283, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 440 then
			enemyShoot(284, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 450 then
			enemyShoot(283, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 476 then
			enemyShoot(286, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 641 then
			enemyShoot(297, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 686 then
			enemyShoot(300, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 729 then
			enemyShoot(304, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 775 then
			enemyShoot(305, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 790 then
			enemyShoot(308, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 830 then
			enemyShoot(307, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 874 then
			enemyShoot(307, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 902 then
			enemyShoot(308, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 986 then
			enemyShoot(308, 0.0, 0.0, false, 0, 0)
		--wave 5
		elseif aScrollProgress == 3430 then
			enemyShoot(395, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3538 then
			enemyShoot(398, 0.0, 0.0, false, 0, 0)
		--wave 8
		elseif aScrollProgress == 6828 then
			enemyShoot(506, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 6886 then
			enemyShoot(507, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 7522 then
			enemyShoot(521, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 7556 then
			enemyShoot(522, 0.0, 0.0, false, 0, 0)
		end
		
	
	
	
	
	elseif globLevel == 3 then
	
		if aScrollProgress == 1 then
			globLevelMusic = level3Music
			globLevelMusic:setVolume(1.0)
			globLevelMusic:stop()
			globLevelMusic:play()
			
		elseif aScrollProgress == 517 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10062)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 150, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 553 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10063)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 170, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 589 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10064)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 150, 66)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,60)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 230, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
		
		elseif aScrollProgress == 622 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10065)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 130, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 630 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10066)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 175, 20)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 100,(-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
		
		elseif aScrollProgress == 660 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10067)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 175, 113)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 100, 151)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, 151)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
		
		elseif aScrollProgress == 710 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10068)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 80, 30)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 100,(-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 719 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10070)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 155, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 740 then
		
			--globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10069)
				
			--globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 80, 103)
			--globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 100, 151)
			--globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, 151)
			--globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			--globEnemyWIndex = globEnemyWIndex + 1
			--if globEnemyWIndex > globMaxEnemyW then
			--	globEnemyWIndex = 1
			--end
			
		elseif aScrollProgress == 741 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10071)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 155, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 1.7)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 755 then--aScrollProgress == 770 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10072)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 150, 66)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,60)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 230, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
		
		elseif aScrollProgress == 820 then
		
			--globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10073)
				
			--globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 50, 40)
			--globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 110,(-1)*20)
			--globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 10, (-1)*20)
			--globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			--globEnemyWIndex = globEnemyWIndex + 1
			--if globEnemyWIndex > globMaxEnemyW then
			--	globEnemyWIndex = 1
			--end
			
		elseif aScrollProgress == 830 then--aScrollProgress == 870 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10074)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 50, 93)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 110, 151)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 10, 151)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10075)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 165, 67)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 40, (-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, 67)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
		
		elseif aScrollProgress == 915 then--aScrollProgress == 950 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10076)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 100, 67)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 100, (-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
		
		elseif aScrollProgress == 970 then--aScrollProgress == 1000 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10077)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 150, 125)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 70, 151)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 180, 151)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
		
		elseif aScrollProgress == 1030 then--aScrollProgress == 1050 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10078)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 20, 5)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 160, (-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], (-1)*20, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10079)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 20, 125)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 160, 151)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], (-1)*20, 151)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 1100 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10080)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 155, 65)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 125,(-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], (-1)*20, 65)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
		
		elseif aScrollProgress == 1170 then
		
		
			--globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10081)
				
			--globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 120, 50)
			--globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,80)
			--globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 50, (-1)*20)
			--globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			--globEnemyWIndex = globEnemyWIndex + 1
			--if globEnemyWIndex > globMaxEnemyW then
			--	globEnemyWIndex = 1
			--end
		
		
		elseif aScrollProgress == 1230 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10082)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 60, 100)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 110,(-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 150, 170)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 1280 then
			
			--globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10083)
				
			--globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 100, 70)
			--globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 40,(-1)*20)
			--globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, 50)
			--globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			--globEnemyWIndex = globEnemyWIndex + 1
			--if globEnemyWIndex > globMaxEnemyW then
			--	globEnemyWIndex = 1
			--end
		
		elseif aScrollProgress == 1340 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10084)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 160, 40)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,40)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10085)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 160, 90)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,90)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, 160)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		--elseif aScrollProgress == 1400 then
		
		--	globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10086)
				
		--	globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 60, 80)
		--	globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 180,(-1)*20)
		--	globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 100, 160)
		--	globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
		--	globEnemyWIndex = globEnemyWIndex + 1
		--	if globEnemyWIndex > globMaxEnemyW then
		--		globEnemyWIndex = 1
		--	end
		
		--elseif aScrollProgress == 1450 then
		
		--	globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10087)
				
		--	globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 110, 55)
		--	globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 180,(-1)*20)
		--	globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 140, (-1)*20)
		--	globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
		--	globEnemyWIndex = globEnemyWIndex + 1
		--	if globEnemyWIndex > globMaxEnemyW then
		--		globEnemyWIndex = 1
		--	end
		elseif aScrollProgress == 1425 then--new
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 11000)--new albeit much higher oid
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 85, 70)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 40,(-1)*20)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 140, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 1520 then--aScrollProgress == 1510 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10088)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 180, 67)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 210,160)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], (-1)*20, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 1560 then
		
			--globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10089)
				
			--globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 155, 65)
			--globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], 125,(-1)*20)
			--globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], (-1)*20, 65)
			--globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			--globEnemyWIndex = globEnemyWIndex + 1
			--if globEnemyWIndex > globMaxEnemyW then
			--	globEnemyWIndex = 1
			--end
			
		elseif aScrollProgress == 1600 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10090)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 110, (-1)*12)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], 2.4)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 1615 then
		
			globEnemyN[globEnemyNIndex].setOid(globEnemyN[globEnemyNIndex], 10091)
			--
			globEnemyN[globEnemyNIndex].putStartPosition(globEnemyN[globEnemyNIndex], 95, 151)
			globEnemyN[globEnemyNIndex].activate(globEnemyN[globEnemyNIndex], (-1)*2.4)
			globEnemyNIndex = globEnemyNIndex + 1
			if globEnemyNIndex > globMaxEnemyN then
				globEnemyNIndex = 1
			end
		
		elseif aScrollProgress == 1620 then
		
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10092)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 110, 40)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,40)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, (-1)*20)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
			globEnemyW[globEnemyWIndex].setOid(globEnemyW[globEnemyWIndex], 10093)
				
			globEnemyW[globEnemyWIndex].setStartDestCoordinate(globEnemyW[globEnemyWIndex], 110, 90)
			globEnemyW[globEnemyWIndex].setContinueDestCoordinate(globEnemyW[globEnemyWIndex], (-1)*20,90)
			globEnemyW[globEnemyWIndex].putStartPosition(globEnemyW[globEnemyWIndex], 210, 160)
			globEnemyW[globEnemyWIndex].activate(globEnemyW[globEnemyWIndex], 2.5)
			globEnemyWIndex = globEnemyWIndex + 1
			if globEnemyWIndex > globMaxEnemyW then
				globEnemyWIndex = 1
			end
			
		elseif aScrollProgress == 2415 then
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10094)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 100, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10104)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 190, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
		
		
		elseif aScrollProgress == 2485 then
		
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10095)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 50, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10096)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 150, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
		elseif aScrollProgress == 2560 then
		
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10097)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 120, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10105)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 215, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
		elseif aScrollProgress == 2630 then
		
		
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10098)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 70, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10099)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 170, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
		elseif aScrollProgress == 2720 then
			
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10100)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 150, (-1)*10)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, 1.0)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
			
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10102)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 190, (-1)*10)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, 1.0)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
		
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10101)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 150, 160)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, (-1)*1.0)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
			
			globEnemyH[globEnemyHIndex].setOid(globEnemyH[globEnemyHIndex], 10103)
			--
			globEnemyH[globEnemyHIndex].putStartPosition(globEnemyH[globEnemyHIndex], 190, 160)
			globEnemyH[globEnemyHIndex].activate(globEnemyH[globEnemyHIndex], 1.0, (-1)*1.0)
			globEnemyHIndex = globEnemyHIndex + 1
			if globEnemyHIndex > globMaxEnemyH then
				globEnemyHIndex = 1
			end
			
		elseif aScrollProgress == 3100 then	
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10106)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 190, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10110)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 173, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10107)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 215, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10111)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 198, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
		elseif aScrollProgress == 3110 then	
		
			--insert enemy k one
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			local lclP11X = 0
			local lclP11Y = 0
			local lclP12X = 0
			local lclP12Y = 0
			
			lclP1X = 210
			lclP1Y = 15
			lclP2X = 210
			lclP2Y = 15
			lclP3X = 180
			lclP3Y = 15
			lclP4X = 170
			lclP4Y = 120
			lclP5X = 140
			lclP5Y = 120
			lclP6X = 150
			lclP6Y = 80
			lclP7X = 190
			lclP7Y = 80
			lclP8X = 190
			lclP8Y = 55
			lclP9X = 70
			lclP9Y = 65
			lclP10X = 80
			lclP10Y = 100
			lclP11X = -50
			lclP11Y = 100
			lclP12X = -50
			lclP12Y = 100
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[11] = Point()
			lclPts[12] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			lclPts[11].putPosition(lclPts[11], lclP11X, lclP11Y)
			lclPts[12].putPosition(lclPts[12], lclP12X, lclP12Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			--
			lclSplines[8] =  CatmullRomSpline()
			lclSplines[8].setGoodDist(lclSplines[8], lclGoodDist)
			lclSplines[8].setRefPoints(lclSplines[8], lclPts[8], lclPts[9], lclPts[10], lclPts[11])
			lclSplines[8].calculate(lclSplines[8])
			--
			lclSplines[9] =  CatmullRomSpline()
			lclSplines[9].setGoodDist(lclSplines[9], lclGoodDist)
			lclSplines[9].setRefPoints(lclSplines[9], lclPts[9], lclPts[10], lclPts[11], lclPts[12])
			lclSplines[9].calculate(lclSplines[9])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			lclTrack.addSpline(lclTrack, lclSplines[8])
			lclTrack.addSpline(lclTrack, lclSplines[9])
			
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10114)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 15)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end


		
		elseif aScrollProgress == 3205 then	
		
		
			--insert enemy k two
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			local lclP11X = 0
			local lclP11Y = 0
			local lclP12X = 0
			local lclP12Y = 0
			local lclP13X = 0
			local lclP13Y = 0
			local lclP14X = 0
			local lclP14Y = 0
			
			lclP1X = 210
			lclP1Y = 25
			lclP2X = 210
			lclP2Y = 25
			lclP3X = 175
			lclP3Y = 25
			lclP4X = 175
			lclP4Y = 125
			lclP5X = 100
			lclP5Y = 125
			lclP6X = 100
			lclP6Y = 35
			lclP7X = 130
			lclP7Y = 35
			lclP8X = 130
			lclP8Y = 80
			lclP9X = 70
			lclP9Y = 80
			lclP10X = 70
			lclP10Y = 120
			lclP11X = 40
			lclP11Y = 120
			lclP12X = 40
			lclP12Y = 35
			lclP13X = -50
			lclP13Y = 35
			lclP14X = -50
			lclP14Y = 35
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[11] = Point()
			lclPts[12] = Point()
			lclPts[13] = Point()
			lclPts[14] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			lclPts[11].putPosition(lclPts[11], lclP11X, lclP11Y)
			lclPts[12].putPosition(lclPts[12], lclP12X, lclP12Y)
			lclPts[13].putPosition(lclPts[13], lclP13X, lclP13Y)
			lclPts[14].putPosition(lclPts[14], lclP14X, lclP14Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			--
			lclSplines[8] =  CatmullRomSpline()
			lclSplines[8].setGoodDist(lclSplines[8], lclGoodDist)
			lclSplines[8].setRefPoints(lclSplines[8], lclPts[8], lclPts[9], lclPts[10], lclPts[11])
			lclSplines[8].calculate(lclSplines[8])
			--
			lclSplines[9] =  CatmullRomSpline()
			lclSplines[9].setGoodDist(lclSplines[9], lclGoodDist)
			lclSplines[9].setRefPoints(lclSplines[9], lclPts[9], lclPts[10], lclPts[11], lclPts[12])
			lclSplines[9].calculate(lclSplines[9])
			--
			lclSplines[10] =  CatmullRomSpline()
			lclSplines[10].setGoodDist(lclSplines[10], lclGoodDist)
			lclSplines[10].setRefPoints(lclSplines[10], lclPts[10], lclPts[11], lclPts[12], lclPts[13])
			lclSplines[10].calculate(lclSplines[10])
			--
			lclSplines[11] =  CatmullRomSpline()
			lclSplines[11].setGoodDist(lclSplines[11], lclGoodDist)
			lclSplines[11].setRefPoints(lclSplines[11], lclPts[11], lclPts[12], lclPts[13], lclPts[14])
			lclSplines[11].calculate(lclSplines[11])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			lclTrack.addSpline(lclTrack, lclSplines[8])
			lclTrack.addSpline(lclTrack, lclSplines[9])
			lclTrack.addSpline(lclTrack, lclSplines[10])
			lclTrack.addSpline(lclTrack, lclSplines[11])
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10115)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 25)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end
			
			
		elseif aScrollProgress == 3280 then	




			--insert enemy k seven
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			
			lclP1X = 210
			lclP1Y = 65
			lclP2X = 210
			lclP2Y = 65
			lclP3X = 160
			lclP3Y = 65
			lclP4X = 160
			lclP4Y = 20
			lclP5X = 120
			lclP5Y = 20
			lclP6X = 120
			lclP6Y = 120
			lclP7X = 80
			lclP7Y = 120
			lclP8X = 80
			lclP8Y = 65
			lclP9X = (-1)*50
			lclP9Y = 65
			lclP10X = (-1)*50
			lclP10Y = 65
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10116)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 65)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end

		elseif aScrollProgress == 3390 then	
		
		
		

			--insert enemy k four
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			local lclP11X = 0
			local lclP11Y = 0
			local lclP12X = 0
			local lclP12Y = 0
			local lclP13X = 0
			local lclP13Y = 0
			local lclP14X = 0
			local lclP14Y = 0
			
			lclP1X = 210
			lclP1Y = 50
			lclP2X = 210
			lclP2Y = 50
			lclP3X = 175
			lclP3Y = 20
			lclP4X = 160
			lclP4Y = 75
			lclP5X = 180
			lclP5Y = 110
			lclP6X = 100
			lclP6Y = 120
			lclP7X = 30
			lclP7Y = 105
			lclP8X = 65
			lclP8Y = 60
			lclP9X = 50
			lclP9Y = 25
			lclP10X = 30
			lclP10Y = 40
			lclP11X = 70
			lclP11Y = 80
			lclP12X = 45
			lclP12Y = 95
			lclP13X = -50
			lclP13Y = 80
			lclP14X = -50
			lclP14Y = 80
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[11] = Point()
			lclPts[12] = Point()
			lclPts[13] = Point()
			lclPts[14] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			lclPts[11].putPosition(lclPts[11], lclP11X, lclP11Y)
			lclPts[12].putPosition(lclPts[12], lclP12X, lclP12Y)
			lclPts[13].putPosition(lclPts[13], lclP13X, lclP13Y)
			lclPts[14].putPosition(lclPts[14], lclP14X, lclP14Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			--
			lclSplines[8] =  CatmullRomSpline()
			lclSplines[8].setGoodDist(lclSplines[8], lclGoodDist)
			lclSplines[8].setRefPoints(lclSplines[8], lclPts[8], lclPts[9], lclPts[10], lclPts[11])
			lclSplines[8].calculate(lclSplines[8])
			--
			lclSplines[9] =  CatmullRomSpline()
			lclSplines[9].setGoodDist(lclSplines[9], lclGoodDist)
			lclSplines[9].setRefPoints(lclSplines[9], lclPts[9], lclPts[10], lclPts[11], lclPts[12])
			lclSplines[9].calculate(lclSplines[9])
			--
			lclSplines[10] =  CatmullRomSpline()
			lclSplines[10].setGoodDist(lclSplines[10], lclGoodDist)
			lclSplines[10].setRefPoints(lclSplines[10], lclPts[10], lclPts[11], lclPts[12], lclPts[13])
			lclSplines[10].calculate(lclSplines[10])
			--
			lclSplines[11] =  CatmullRomSpline()
			lclSplines[11].setGoodDist(lclSplines[11], lclGoodDist)
			lclSplines[11].setRefPoints(lclSplines[11], lclPts[11], lclPts[12], lclPts[13], lclPts[14])
			lclSplines[11].calculate(lclSplines[11])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			lclTrack.addSpline(lclTrack, lclSplines[8])
			lclTrack.addSpline(lclTrack, lclSplines[9])
			lclTrack.addSpline(lclTrack, lclSplines[10])
			lclTrack.addSpline(lclTrack, lclSplines[11])
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10117)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 50)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end


		
			
		elseif aScrollProgress == 3400 then	
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10108)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 190, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10112)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 173, (-1)*15)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], 1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10109)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 215, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
			globEnemyD[globEnemyDIndex].setOid(globEnemyD[globEnemyDIndex], 10113)
			--
			globEnemyD[globEnemyDIndex].putStartPosition(globEnemyD[globEnemyDIndex], 198, 215)
			globEnemyD[globEnemyDIndex].activate(globEnemyD[globEnemyDIndex], (-1)*1.9)
			globEnemyDIndex = globEnemyDIndex + 1
			if globEnemyDIndex > globMaxEnemyD then
				globEnemyDIndex = 1
			end
			
		
		elseif aScrollProgress == 3480 then	
		
					--insert enemy k five
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			local lclP11X = 0
			local lclP11Y = 0
			local lclP12X = 0
			local lclP12Y = 0
			
			lclP1X = 210
			lclP1Y = 125
			lclP2X = 210
			lclP2Y = 125
			lclP3X = 160
			lclP3Y = 125
			lclP4X = 160
			lclP4Y = 70
			lclP5X = 175
			lclP5Y = 70
			lclP6X = 175
			lclP6Y = 100
			lclP7X = 60
			lclP7Y = 100
			lclP8X = 60
			lclP8Y = 20
			lclP9X = 80
			lclP9Y = 20
			lclP10X = 80
			lclP10Y = 75
			lclP11X = -50
			lclP11Y = 75
			lclP12X = -50
			lclP12Y = 75
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[11] = Point()
			lclPts[12] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			lclPts[11].putPosition(lclPts[11], lclP11X, lclP11Y)
			lclPts[12].putPosition(lclPts[12], lclP12X, lclP12Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			--
			lclSplines[8] =  CatmullRomSpline()
			lclSplines[8].setGoodDist(lclSplines[8], lclGoodDist)
			lclSplines[8].setRefPoints(lclSplines[8], lclPts[8], lclPts[9], lclPts[10], lclPts[11])
			lclSplines[8].calculate(lclSplines[8])
			--
			lclSplines[9] =  CatmullRomSpline()
			lclSplines[9].setGoodDist(lclSplines[9], lclGoodDist)
			lclSplines[9].setRefPoints(lclSplines[9], lclPts[9], lclPts[10], lclPts[11], lclPts[12])
			lclSplines[9].calculate(lclSplines[9])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			lclTrack.addSpline(lclTrack, lclSplines[8])
			lclTrack.addSpline(lclTrack, lclSplines[9])
			
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10118)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 125)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end



		
		elseif aScrollProgress == 3550 then	
		
		
		

			--insert enemy k six
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			local lclP9X = 0
			local lclP9Y = 0
			local lclP10X = 0
			local lclP10Y = 0
			
			lclP1X = 210
			lclP1Y = 35
			lclP2X = 210
			lclP2Y = 35
			lclP3X = 100
			lclP3Y = 35
			lclP4X = 100
			lclP4Y = 115
			lclP5X = 135
			lclP5Y = 115
			lclP6X = 135
			lclP6Y = 80
			lclP7X = 70
			lclP7Y = 80
			lclP8X = 70
			lclP8Y = 110
			lclP9X = (-1)*50
			lclP9Y = 110
			lclP10X = (-1)*50
			lclP10Y = 110
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[9] = Point()
			lclPts[10] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			lclPts[9].putPosition(lclPts[9], lclP9X, lclP9Y)
			lclPts[10].putPosition(lclPts[10], lclP10X, lclP10Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			--
			lclSplines[6] =  CatmullRomSpline()
			lclSplines[6].setGoodDist(lclSplines[6], lclGoodDist)
			lclSplines[6].setRefPoints(lclSplines[6], lclPts[6], lclPts[7], lclPts[8], lclPts[9])
			lclSplines[6].calculate(lclSplines[6])
			--
			lclSplines[7] =  CatmullRomSpline()
			lclSplines[7].setGoodDist(lclSplines[7], lclGoodDist)
			lclSplines[7].setRefPoints(lclSplines[7], lclPts[7], lclPts[8], lclPts[9], lclPts[10])
			lclSplines[7].calculate(lclSplines[7])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			lclTrack.addSpline(lclTrack, lclSplines[6])
			lclTrack.addSpline(lclTrack, lclSplines[7])
			
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10119)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 35)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end



		
		elseif aScrollProgress == 3600 then	
		
		

			--insert enemy k three
			
			local lclTrack = Track()
			
			
			--points for catmull-rom spline
			local lclP1X = 0
			local lclP1Y = 0
			local lclP2X = 0
			local lclP2Y = 0
			local lclP3X = 0
			local lclP3Y = 0
			local lclP4X = 0
			local lclP4Y = 0
			local lclP5X = 0
			local lclP5Y = 0
			local lclP6X = 0
			local lclP6Y = 0
			local lclP7X = 0
			local lclP7Y = 0
			local lclP8X = 0
			local lclP8Y = 0
			
			lclP1X = 210
			lclP1Y = 120
			lclP2X = 210
			lclP2Y = 120
			lclP3X = 165
			lclP3Y = 120
			lclP4X = 155
			lclP4Y = 30
			lclP5X = 135
			lclP5Y = 30
			lclP6X = 120
			lclP6Y = 90
			lclP7X = -50
			lclP7Y = 70
			lclP8X = -50
			lclP8Y = 70
			
			local lclPts = {}
			lclPts[1] = Point()
			lclPts[2] = Point()
			lclPts[3] = Point()
			lclPts[4] = Point()
			lclPts[5] = Point()
			lclPts[6] = Point()
			lclPts[7] = Point()
			lclPts[8] = Point()
			lclPts[1].putPosition(lclPts[1], lclP1X, lclP1Y)
			lclPts[2].putPosition(lclPts[2], lclP2X, lclP2Y)
			lclPts[3].putPosition(lclPts[3], lclP3X, lclP3Y)
			lclPts[4].putPosition(lclPts[4], lclP4X, lclP4Y)
			lclPts[5].putPosition(lclPts[5], lclP5X, lclP5Y)
			lclPts[6].putPosition(lclPts[6], lclP6X, lclP6Y)
			lclPts[7].putPosition(lclPts[7], lclP7X, lclP7Y)
			lclPts[8].putPosition(lclPts[8], lclP8X, lclP8Y)
			
			local lclSplines = {}
			local lclGoodDist = 1.2
			--
			lclSplines[1] =  CatmullRomSpline()
			lclSplines[1].setGoodDist(lclSplines[1], lclGoodDist)
			lclSplines[1].setRefPoints(lclSplines[1], lclPts[1], lclPts[2], lclPts[3], lclPts[4])
			lclSplines[1].calculate(lclSplines[1])
			--
			lclSplines[2] =  CatmullRomSpline()
			lclSplines[2].setGoodDist(lclSplines[2], lclGoodDist)
			lclSplines[2].setRefPoints(lclSplines[2], lclPts[2], lclPts[3], lclPts[4], lclPts[5])
			lclSplines[2].calculate(lclSplines[2])
			--
			lclSplines[3] =  CatmullRomSpline()
			lclSplines[3].setGoodDist(lclSplines[3], lclGoodDist)
			lclSplines[3].setRefPoints(lclSplines[3], lclPts[3], lclPts[4], lclPts[5], lclPts[6])
			lclSplines[3].calculate(lclSplines[3])
			--
			lclSplines[4] =  CatmullRomSpline()
			lclSplines[4].setGoodDist(lclSplines[4], lclGoodDist)
			lclSplines[4].setRefPoints(lclSplines[4], lclPts[4], lclPts[5], lclPts[6], lclPts[7])
			lclSplines[4].calculate(lclSplines[4])
			--
			lclSplines[5] =  CatmullRomSpline()
			lclSplines[5].setGoodDist(lclSplines[5], lclGoodDist)
			lclSplines[5].setRefPoints(lclSplines[5], lclPts[5], lclPts[6], lclPts[7], lclPts[8])
			lclSplines[5].calculate(lclSplines[5])
			
			--put splines together to track
			lclTrack.addSpline(lclTrack, lclSplines[1])
			lclTrack.addSpline(lclTrack, lclSplines[2])
			lclTrack.addSpline(lclTrack, lclSplines[3])
			lclTrack.addSpline(lclTrack, lclSplines[4])
			lclTrack.addSpline(lclTrack, lclSplines[5])
			
			
			globEnemyK[globEnemyKIndex].setOid(globEnemyK[globEnemyKIndex], 10120)
			--
			globEnemyK[globEnemyKIndex].setTrack(globEnemyK[globEnemyKIndex],lclTrack)
			--
			globEnemyK[globEnemyKIndex].putStartPosition(globEnemyK[globEnemyKIndex], 210, 120)
			globEnemyK[globEnemyKIndex].activate(globEnemyK[globEnemyKIndex])
			globEnemyKIndex = globEnemyKIndex + 1
			if globEnemyKIndex > globMaxEnemyK then
				globEnemyKIndex = 1
			end
			
			
		elseif aScrollProgress == 6000 then	
			
			globEnemyZ[globEnemyZIndex].setOid(globEnemyZ[globEnemyZIndex], 10121)
			--
			globEnemyZ[globEnemyZIndex].setStartTimer(globEnemyZ[globEnemyZIndex], 40)
			globEnemyZ[globEnemyZIndex].setCycles(globEnemyZ[globEnemyZIndex], 23)
			globEnemyZ[globEnemyZIndex].putStartPosition(globEnemyZ[globEnemyZIndex], 200, 115)
			globEnemyZ[globEnemyZIndex].activate(globEnemyZ[globEnemyZIndex], 0.5)
			globEnemyZIndex = globEnemyZIndex + 1
			if globEnemyZIndex > globMaxEnemyZ then
				globEnemyZIndex = 1
			end
			
			globEnemyZ[globEnemyZIndex].setOid(globEnemyZ[globEnemyZIndex], 10122)
			--
			globEnemyZ[globEnemyZIndex].setStartTimer(globEnemyZ[globEnemyZIndex], 40)
			globEnemyZ[globEnemyZIndex].setCycles(globEnemyZ[globEnemyZIndex], 31)
			globEnemyZ[globEnemyZIndex].putStartPosition(globEnemyZ[globEnemyZIndex], 200, 85)
			globEnemyZ[globEnemyZIndex].activate(globEnemyZ[globEnemyZIndex], 0.5)
			globEnemyZIndex = globEnemyZIndex + 1
			if globEnemyZIndex > globMaxEnemyZ then
				globEnemyZIndex = 1
			end
			
		elseif aScrollProgress == 6600 then

			globEnemyZ[globEnemyZIndex].setOid(globEnemyZ[globEnemyZIndex], 10123)
			--
			globEnemyZ[globEnemyZIndex].setStartTimer(globEnemyZ[globEnemyZIndex], 40)
			globEnemyZ[globEnemyZIndex].setCycles(globEnemyZ[globEnemyZIndex], 20)
			globEnemyZ[globEnemyZIndex].putStartPosition(globEnemyZ[globEnemyZIndex], 200, 100)
			globEnemyZ[globEnemyZIndex].activate(globEnemyZ[globEnemyZIndex], 0.5)
			globEnemyZIndex = globEnemyZIndex + 1
			if globEnemyZIndex > globMaxEnemyZ then
				globEnemyZIndex = 1
			end
		
		elseif aScrollProgress == 7600 then
		
			globBossBack.putStartPosition(globBossBack, 200, 0) --deactivated in boss3explosion, so will dissappear with boss
			globBossBack.activate(globBossBack)
			
			
		elseif aScrollProgress == 7600 then	
			globLevelMusic:setVolume(0.9)
		elseif aScrollProgress == 7620 then	
			globLevelMusic:setVolume(0.8)
		elseif aScrollProgress == 7640 then	
			globLevelMusic:setVolume(0.7)
		elseif aScrollProgress == 7660 then	
			globLevelMusic:setVolume(0.6)
		elseif aScrollProgress == 7680 then	
			globLevelMusic:setVolume(0.5)
		elseif aScrollProgress == 7700 then	
			globLevelMusic:setVolume(0.4)
		elseif aScrollProgress == 7720 then	
			globLevelMusic:setVolume(0.3)
		elseif aScrollProgress == 7740 then	
			globLevelMusic:setVolume(0.2)
		elseif aScrollProgress == 7760 then	
			globLevelMusic:setVolume(0.1)
		elseif aScrollProgress == 7780 then	
			globLevelMusic:stop()
			
		elseif aScrollProgress == 7799 then	
		
			--Boss 3
			
			globEnemyBoss3.putStartPosition(globEnemyBoss3, 200, 59)
			globEnemyBoss3.activate(globEnemyBoss3)
			
			globLevelMusic = bossMusic
			globLevelMusic:setVolume(1.0)
			globLevelMusic:stop()
			globLevelMusic:play()
		
		end
		
	
		
	
		--have enemies shoot
		if aScrollProgress == 87 then
			enemyShoot(527, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 134 then
			enemyShoot(526, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 170 then
			enemyShoot(529, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 199 then
			enemyShoot(532, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 225 then
			enemyShoot(533, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 315 then
			enemyShoot(534, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 346 then
			enemyShoot(542, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 351 then
			enemyShoot(541, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 356 then
			enemyShoot(543, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 415 then
			enemyShoot(546, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 426 then
			enemyShoot(541, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 475 then
			enemyShoot(542, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 542 then
			enemyShoot(541, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 545 then
			enemyShoot(542, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 1187 then
			enemyShoot(566, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1210 then
			enemyShoot(568, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1345 then
			enemyShoot(573, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1380 then
			enemyShoot(586, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1414 then
			enemyShoot(580, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1530 then
			enemyShoot(588, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1607 then
			enemyShoot(589, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1720 then
			enemyShoot(596, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1759 then
			enemyShoot(599, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1792 then
			enemyShoot(603, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1815 then
			enemyShoot(608, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 1866 then
			enemyShoot(607, 0.0, 0.0, false, 0, 0)
			enemyShoot(608, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 1893 then
			enemyShoot(604, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1985 then
			enemyShoot(627, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 1994 then
			enemyShoot(607, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2000 then
			enemyShoot(634, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2057 then
			enemyShoot(625, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2070 then
			enemyShoot(633, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2170 then
			enemyShoot(626, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2449 then
			enemyShoot(10094, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2525 then
			enemyShoot(10095, 0.0, 0.0, true, 0, 0)
			enemyShoot(10096, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2628 then
			enemyShoot(10097, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2691 then
			enemyShoot(10098, 0.0, 0.0, true, 0, 0)
			enemyShoot(10099, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 2756 then
			enemyShoot(10100, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2792 then
			enemyShoot(10103, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2854 then
			enemyShoot(10102, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 2895 then
			enemyShoot(10101, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3144 then
			enemyShoot(10114, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3204 then
			enemyShoot(10114, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3254 then
			enemyShoot(10115, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3332 then
			enemyShoot(10116, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3436 then
			enemyShoot(10114, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3478 then
			enemyShoot(10115, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3444 then
			enemyShoot(10117, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3558 then
			enemyShoot(10118, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3619 then
			enemyShoot(10119, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3670 then
			enemyShoot(10120, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 3737 then
			enemyShoot(10120, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 4073 then
			enemyShoot(664, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 4119 then
			enemyShoot(665, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 4169 then
			enemyShoot(671, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 4238 then
			enemyShoot(667, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 4310 then
			enemyShoot(676, 0.0, 0.0, true, 0, 0)
		elseif aScrollProgress == 4327 then
			enemyShoot(683, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 4360 then
			enemyShoot(684, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 4402 then
			enemyShoot(683, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 4451 then
			enemyShoot(684, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 4536 then
			enemyShoot(683, 0.0, 0.0, false, 0, 0)
		elseif aScrollProgress == 4644 then
			enemyShoot(684, 0.0, 0.0, false, 0, 0)
		--wave12
		elseif aScrollProgress == 6050 then
			enemyShoot(10122, (-1)*1.8, (-1)*4.5, true, 0, 0)
		elseif aScrollProgress == 6075 then
			enemyShoot(10121, (-1)*2.2, (-1)*5.9, true, 0, 0)
		elseif aScrollProgress == 6100 then
			enemyShoot(10122, (-1)*0.75, (-1)*5.0, true, 0, 0)
		elseif aScrollProgress == 6125 then
			enemyShoot(10121, (-1)*2.4, (-1)*7.5, true, 0, 0)
		elseif aScrollProgress == 6150 then
			enemyShoot(10122, (-1)*3.5, (-1)*3.0, true, 0, 0)
		elseif aScrollProgress == 6175 then
			enemyShoot(10121, (-1)*2.9, (-1)*5.9, true, 0, 0)
		elseif aScrollProgress == 6200 then
			enemyShoot(10122, (-1)*0.9, (-1)*6.2, true, 0, 0)
		elseif aScrollProgress == 6225 then
			enemyShoot(10121, (-1)*2.4, (-1)*5.9, true, 0, 0)
		elseif aScrollProgress == 6250 then
			enemyShoot(10122, (-1)*5.0, (-1)*5.8, true, 0, 0)
		elseif aScrollProgress == 6275 then
			enemyShoot(10121, (-1)*2.2, (-1)*5.9, true, 0, 0)
		elseif aScrollProgress == 6300 then
			enemyShoot(10122, (-1)*0.8, (-1)*5.9, true, 0, 0)
		elseif aScrollProgress == 6325 then
			enemyShoot(10121, (-1)*0.75, (-1)*5.0, true, 0, 0)
		elseif aScrollProgress == 6350 then
			enemyShoot(10122, (-1)*1.2, (-1)*5.9, true, 0, 0)
		elseif aScrollProgress == 6375 then
			enemyShoot(10121, (-1)*2.8, (-1)*5.9, true, 0, 0)
		--
		elseif aScrollProgress == 6650 then
			enemyShoot(10123, (-1)*1.8, (-1)*4.5, true, 0, 0)
		elseif aScrollProgress == 6675 then
			enemyShoot(10123, (-1)*2.2, (-1)*5.9, true, 0, 0)
		elseif aScrollProgress == 6700 then
			enemyShoot(10123, (-1)*0.75, (-1)*5.0, true, 0, 0)
		elseif aScrollProgress == 6725 then
			enemyShoot(10123, (-1)*2.4, (-1)*7.2, true, 0, 0)
		elseif aScrollProgress == 6750 then
			enemyShoot(10123, (-1)*3.5, (-1)*3.0, true, 0, 0)
		elseif aScrollProgress == 6775 then
			enemyShoot(10123, (-1)*5.0, (-1)*5.8, true, 0, 0)
		elseif aScrollProgress == 6800 then
			enemyShoot(10123, (-1)*2.9, (-1)*5.9, true, 0, 0)
		elseif aScrollProgress == 6825 then
			enemyShoot(10123, (-1)*0.9, (-1)*6.2, true, 0, 0)
		elseif aScrollProgress == 6850 then
			enemyShoot(10123, (-1)*2.2, (-1)*5.9, true, 0, 0)
		elseif aScrollProgress == 6875 then
			enemyShoot(10123, (-1)*0.7, (-1)*5.5, true, 0, 0)
		end
	
	end
	
	
end


function enemyShoot(aOid, aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)


	for i = 1,globMaxEnemyA,1 do
		if globEnemyA[i].active == true and globEnemyA[i].oid == aOid then
			globEnemyA[i].prepareShoot(globEnemyA[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	

	for i = 1,globMaxEnemyB,1 do
		if globEnemyB[i].active == true and globEnemyB[i].oid == aOid then
			globEnemyB[i].prepareShoot(globEnemyB[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	

	for i = 1,globMaxEnemyC,1 do
		if globEnemyC[i].active == true and globEnemyC[i].oid == aOid then
			globEnemyC[i].prepareShoot(globEnemyC[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	

	for i = 1,globMaxEnemyD,1 do
		if globEnemyD[i].active == true and globEnemyD[i].oid == aOid then
			globEnemyD[i].prepareShoot(globEnemyD[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	

	for i = 1,globMaxEnemyE,1 do
		if globEnemyE[i].active == true and globEnemyE[i].oid == aOid then
			globEnemyE[i].prepareShoot(globEnemyE[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	

	for i = 1,globMaxEnemyF,1 do
		if globEnemyF[i].active == true and globEnemyF[i].oid == aOid then
			globEnemyF[i].prepareShoot(globEnemyF[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	if globEnemyG.active == true and globEnemyG.oid == aOid then
		globEnemyG.prepareShoot(globEnemyG, aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
	end
	

	for i = 1,globMaxEnemyH,1 do
		if globEnemyH[i].active == true and globEnemyH[i].oid == aOid then
			globEnemyH[i].prepareShoot(globEnemyH[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	

	for i = 1,globMaxEnemyI,1 do
		if globEnemyI[i].active == true and globEnemyI[i].oid == aOid then 
			globEnemyI[i].prepareShoot(globEnemyI[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	

	for i = 1,globMaxEnemyJ,1 do
		if globEnemyJ[i].active == true and globEnemyJ[i].oid == aOid then
			globEnemyJ[i].prepareShoot(globEnemyJ[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyK,1 do
		if globEnemyK[i].active == true and globEnemyK[i].oid == aOid then
			globEnemyK[i].prepareShoot(globEnemyK[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyL,1 do
		if globEnemyL[i].active == true and globEnemyL[i].oid == aOid then
			globEnemyL[i].prepareShoot(globEnemyL[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyM,1 do
		if globEnemyM[i].active == true and globEnemyM[i].oid == aOid then
			globEnemyM[i].prepareShoot(globEnemyM[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyN,1 do
		if globEnemyN[i].active == true and globEnemyN[i].oid == aOid then
			globEnemyN[i].prepareShoot(globEnemyN[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyO,1 do
		if globEnemyO[i].active == true and globEnemyO[i].oid == aOid then
			globEnemyO[i].prepareShoot(globEnemyO[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyP,1 do
		if globEnemyP[i].active == true and globEnemyP[i].oid == aOid then
			globEnemyP[i].prepareShoot(globEnemyP[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyQ,1 do
		if globEnemyQ[i].active == true and globEnemyQ[i].oid == aOid then
			globEnemyQ[i].prepareShoot(globEnemyQ[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyR,1 do
		if globEnemyR[i].active == true and globEnemyR[i].oid == aOid then
			globEnemyR[i].prepareShoot(globEnemyR[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyS,1 do
		if globEnemyS[i].active == true and globEnemyS[i].oid == aOid then
			globEnemyS[i].prepareShoot(globEnemyS[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyT,1 do
		if globEnemyT[i].active == true and globEnemyT[i].oid == aOid then
			globEnemyT[i].prepareShoot(globEnemyT[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyU,1 do
		if globEnemyU[i].active == true and globEnemyU[i].oid == aOid then
			globEnemyU[i].prepareShoot(globEnemyU[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyV,1 do
		if globEnemyV[i].active == true and globEnemyV[i].oid == aOid then
			globEnemyV[i].prepareShoot(globEnemyV[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyW,1 do
		if globEnemyW[i].active == true and globEnemyW[i].oid == aOid then
			globEnemyW[i].prepareShoot(globEnemyW[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyX,1 do
		if globEnemyX[i].active == true and globEnemyX[i].oid == aOid then
			globEnemyX[i].prepareShoot(globEnemyX[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyY,1 do
		if globEnemyY[i].active == true and globEnemyY[i].oid == aOid then
			globEnemyY[i].prepareShoot(globEnemyY[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end
	
	for i = 1,globMaxEnemyZ,1 do
		if globEnemyZ[i].active == true and globEnemyZ[i].oid == aOid then
			globEnemyZ[i].prepareShoot(globEnemyZ[i], aSpdX, aSpdY, aAimPlyr, aParam1, aParam2)
		end
	end

end


function globAddScore(aScorePlus)

	globScore = globScore + aScorePlus
	
	if globScore > globMaxScore then
		globScore = globMaxScore
	end
	--
	--extralife-relevant-score for player is only counted after joining (so different players may
	--gain lifes at different times, let playership handle when it will accept individual score addition)
	for i = 1,globMaxPlayers,1 do 
		if globPlShip[i] ~= nil then
			globPlShip[i].addScore(globPlShip[i], aScorePlus)
		end
	end
	
end


